﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data;
using System.Data.SqlClient;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Analysis
{
    public class MedicineInteractionAnalysis
    {
        static SqlConnection conn = DBHelper.getConnection();

        public void saveUsefulSentence()
        {
            string sql = "select name,approveNumber,interaction from MedicineInstruction";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string name = dt.Rows[i][0].ToString();
                string approveNumber = dt.Rows[i][1].ToString();
                string interactions = dt.Rows[i][2].ToString();
                String[] values = interactions.Split(new string[] { "。" }, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < values.Length; j++)
                {
                    int notUseIndex1 = values[j].IndexOf("医师");
                    int notUseIndex2 = values[j].IndexOf("药师");
                    if (notUseIndex1 == -1 && notUseIndex2 == -1)
                    {
                        sql = "insert into medicineinteraction(name,approveNumber,interaction) values('" + name + "','" + approveNumber + "','" + values[j] + "')";
                        int result = DBHelper.ExecuteNoResult(sql, conn);
                    }
                }
            }
        }

        public void setMedicineClassify()
        {
            string sql = "select medicinename from medicine group by medicinename";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string name = dt.Rows[i][0].ToString();
                sql = "select text,url from dingxiangyuan where title like '%名称%' and text like '%" + name + "%'";
                DataTable dt2 = DBHelper.ExecuteWithReset(sql, conn);
                if (dt2 == null || dt2.Rows.Count == 0)
                {
                    continue;
                }
                string text = dt2.Rows[0][0].ToString();
                string url = dt2.Rows[0][1].ToString();
                int index = text.IndexOf(name);
                if (index != -1)
                {
                    sql = "select text from dingxiangyuan where title like '%分类%' and url = '" + url + "'";
                    DataTable dt3 = DBHelper.ExecuteWithReset(sql, conn);
                    if (dt3 != null)
                    {
                        for (int j = 0; j < dt3.Rows.Count; j++)
                        {
                            text = dt3.Rows[j][0].ToString();
                            sql = "update medicine set classify = '" + text + "' where medicinename like '%" + name + "%'";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
        }

        public void setTaboo()
        {
            string sql = "select medicineName,classify from medicine";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string medicineName2 = dt.Rows[i][0].ToString();
                string classify = dt.Rows[i][1].ToString().Replace(" ","");
                if (classify == null || classify.Equals("") == true)
                {
                    classify = medicineName2;
                }
                string[] likeList = { "%禁忌%", "%不宜%", "%慎%用%", "%禁%用%", "%忌%用%", "%勿%用%", "%不得%", "%毒性%", "%中毒%", "%增%副作用%", "%增%危险%", "%不应%", "%避免%", "%不能%用%", "%不可%用%", "%致%损害%", "%出血%", "%不推荐%", "%不提倡%", "%增%倾向%", "%影响%效%", "%影响%吸收%", "%抑制%吸收%", "%降低%效果%", "%不良反应%", "%引起%损害%", "%引起%可能%", "%引发%可能%", "%诱发%", "%降低%疗效%", "%疗效%降%", "%降低%作用%", "%降低%吸收%", "%干扰%", "%拮抗%", "%调整%量%", "%量%调整%", "%量%减%", "%致%缺乏%", "%使%缺乏%", "%作用%减弱%", "%减%作用%", "%妨碍%吸收%", "%吸收%减%", "%加剧%", "%延长%作用时间%", "%注意%", "%疗效%减%", "%抽搐%", "%使%过高%", "%症%增%" };
                for (int k = 0; k < likeList.Length; k++)
                {
                    sql = "select name,interaction from medicineinteraction where (interaction like '%" + medicineName2 + "%' or interaction like '%" + classify + "%') and interaction like '" + likeList[k] +"'";
                    DataTable dt2 = DBHelper.ExecuteWithReset(sql, conn);
                    if (dt2 != null && dt2.Rows.Count > 0)
                    {
                        for (int j = 0; j < dt2.Rows.Count; j++)
                        {
                            string medicineName1 = dt2.Rows[j][0].ToString();
                            string discription = likeList[k].Replace("%","_");
                            string indicationOrTaboo = "taboo";
                            string sentence = dt2.Rows[j][1].ToString();
                            sql = "insert into medicinemedicineinteraction(medicinename1,medicinename2,indicationOrTaboo,discription,sentence) values('" + medicineName1 + "','" + medicineName2 + "','" + indicationOrTaboo + "','" + discription + "','" + sentence + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        break;
                    }
                }
            }
        }

        public void setIndication()
        {
            //interaction  like '%提高%作用%' 
            //or interaction  like '%提高%效%'
            //or interaction  like '%增%作用%'
            //or interaction  like '%加强%作用%'
            //or interaction  like '%作用%加强%'
            //or interaction  like '%效果%加强%'
            //or interaction  like '%增%效%'
            //or interaction  like '%药效%增%' 
            //or interaction like '%药效%加%' 
            //or interaction  like '%药效%明显%'
            //or interaction  like '%提高%能力%' 
            //or interaction  like '%降低%反应%'
            //or interaction like '%吸收%增%'
            //or interaction like '%增%吸收%'
            //or interaction like '%促进%'
            //or interaction like '%协同%'
        }
    }
}
