﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace YFDYFKnowledgeDiscovery.Analysis
{
    public class SymptomSymptomAnalysis
    {
        Dao.SymptomSymptomReference dao = new Dao.SymptomSymptomReference();

        public void calculateSymptomReference()
        {
            List<string> symptomList = dao.getSymptomName();
            for (int i = 14; i < 50; i++)
            {
                for (int j = i+1; j < symptomList.Count; j++)
                {
                    String word1 = symptomList[i].Trim();
                    String word2 = symptomList[j].Trim();
                    //int score = dao.countReferenceScore1(word1, word2);
                    int score = dao.countReferenceScore2(word1, word2);
                    if (score > 0)
                    {
                        dao.insertSymptomSymptomReference(word1, word2, score);
                    }
                }
            }
        }
    }
}
