﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class DingXiangYuan
    {
        //获取数据库连接
        static SqlConnection conn = DBHelper.getConnection();

        /// <summary>
        /// 从数据库中读取所有的商品列表
        /// </summary>
        /// <param name="url">商品的地址</param>
        public List<string> GetMedicineList()
        {
            List<string> urlList = new List<string>();
            try
            {
                string sql = "select distinct(name) from MedicineInstruction union select distinct(medicineName) from MedicineNonInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
                return urlList;
            }
            catch (Exception ex)
            {
                
            }
            return null;
        }

        /// <summary>
        /// 插入商品的地址
        /// </summary>
        /// <param name="url">商品的地址</param>
        public void InsertLinShiUrl(string url, string name)
        {
            try
            {
                string sql = "insert into LinShiDingXiangYuan(url,name) values('" + url + "','" + name + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }


        public List<string> GetMedicineUrlList()
        {
            List<string> urlList = new List<string>();
            try
            {
                string sql = "select distinct(url) from LinShiDingXiangYuan where flag is null";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
                return urlList;
            }
            catch (Exception ex)
            {
                return null;
            }
        }

        // insert into DingXiangYuan(commonName,component,indication,badEffect,taboo,warning,attetion,interaction,approveNumber,scope)  values()
        /// <summary>
        /// 
        /// </summary>
        /// <param name="commonName"></param>
        /// <param name="component"></param>
        /// <param name="indication"></param>
        /// <param name="badEffect"></param>
        /// <param name="taboo"></param>
        /// <param name="warning"></param>
        /// <param name="attetion"></param>
        /// <param name="interaction"></param>
        /// <param name="approveNumber"></param>
        /// <param name="scope"></param>
        public void InsertDingXiangYuanDetail(string title, string text,string url)
        {
            try
            {
                string sql = "insert into DingXiangYuan(title,text,url) " +
                " values('" + title + "','" + text + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }
        /// <summary>
        /// 更新商品的url状态，访问过为1，否则为null
        /// </summary>
        /// <param name="url"></param>
        public void UpdateFlagByUrl(string url)
        {
            try
            {
                string sql = "update LinShiDingXiangYuan set flag=1 where url='" + url + "'";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }
    }
}
