﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{

    public class YaoPin
    {
        
        static SqlConnection conn = DBHelper.getConnection();

        public int saveYaoPinData(string name, string url, string text)
        {
            string sql = "insert into YaoJianJu(name,url,text) ";
            sql += "values('" + name + "','" + url + "','" + text + "')";
            int result = DBHelper.ExecuteNoResult(sql, conn);
            return result;
        }

        public DataTable getYaoPinData()
        {
            string sql = "select id,text from YaoJianJu where len(text)>20 and id>10000";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            return dt;
        }

        public void upDateYaoPinSplitData(String sql)
        {
            DBHelper.ExecuteNoResult(sql, conn);
        }

        public List<String> getValue(String tableName, String valueName)
        {
            List<String> valueList = new List<string>();
            try
            {
                string sql = "select " + valueName + " from " + tableName + " where LEN(" + valueName + ")>0";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }
        
        public List<String> getValue(String tableName, String valueName, List<String> list)
        {
            List<String> valueList = list;
            try
            {
                string sql = "select " + valueName + " from " + tableName + " where LEN(" + valueName + ")>0";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }
        
        public void insertValue(String valueName, String text)
        {
            try
            {
                string sql = "insert into analysis(text,name) values('" + text + "','" + valueName + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }
        
        public List<String> getValueGroup(String valueName)
        {
            List<String> valueList = new List<string>();
            try
            {
                string sql = "select text from analysis where name='" + valueName + "' group by text";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }
        
        public void insertValueGroup(String tableName, String valueName, String text)
        {
            try
            {
                string sql = "insert into " + tableName + "(" + valueName + ") values('" + text + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public DataTable getMedicineNonInstruction()
        {
            DataTable dt = null;
            try
            {
                string sql = "select a.name,pizhunwenhao,shengchandanwei,shengchandizhi,chanpinleibie,a.url from YaoJianJu as a where pizhunwenhao not in (select approveNumber from MedicineInstruction as b)";
                dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
            return dt;
        }

        public void insertMedicineNonInstruction(String medicineName, String approveNumber, String enterprise, String address,String type,String url)
        {
            try
            {
                string sql = "insert into MedicineNonInstruction(medicineName,approveNumber,enterprise,address,type,url) values('" + medicineName + "','" + approveNumber + "','" + enterprise + "','" + address + "','" + type + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public List<string> getMedicineNonInstructionName()
        {
            List<string> list = new List<string>();
            try
            {
                string sql = "select medicineName from MedicineNonInstruction group by medicineName";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    list.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return list;
        }

        public void updateMedicineNonInstructionComponent(String medicineName)
        {
            try
            {
                String sql = "select a.name,a.value from BaiKeDetail a,MedicineNonInstruction b where (a.name like '%成分%' or a.name like '%成份%') and a.yaopin=b.medicineName and a.yaopin='" + medicineName + "'";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                if (dt.Rows.Count > 0)
                {
                    String name = dt.Rows[0][0].ToString();
                    String value = dt.Rows[0][1].ToString();
                    sql = "update MedicineNonInstruction set component='" + value + "' where medicineName='" + medicineName + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
            catch
            {

            }
        }

        public void updateMedicineNonInstructionIndication(String medicineName)
        {
            try
            {
                String sql = "select a.name,a.value from BaiKeDetail a,MedicineNonInstruction b where (a.name like '%功能%' or a.name like '%主治%' or a.name like '%适应%') and a.yaopin=b.medicineName and a.yaopin='" + medicineName + "'";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                if (dt.Rows.Count > 0)
                {
                    String name = dt.Rows[0][0].ToString();
                    String value = dt.Rows[0][1].ToString();
                    sql = "update MedicineNonInstruction set indication='" + value + "' where medicineName='" + medicineName + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
            catch
            {

            }
        }

        public void updateMedicineNonInstructionPopulation(String medicineName)
        {
            try
            {
                String sql = "select a.name,a.value from BaiKeDetail a,MedicineNonInstruction b where ((a.name like '%者%' or name like '%人%' or a.name like '%男%' or a.name like '%女%' or a.name like '%儿童%' or a.name like '%妇%' or a.name like '%孕%' or a.name like '%老%') and a.name not like '%适应症%' and a.name not like '%用法%' and a.name not like '%注意事项%' and a.name not like '%执行%' and a.name not like '%主治%') and a.yaopin=b.medicineName and a.yaopin='" + medicineName + "'";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                if (dt.Rows.Count > 0)
                {
                    String name = dt.Rows[0][0].ToString();
                    String value = dt.Rows[0][1].ToString();
                    sql = "update MedicineNonInstruction set population='" + name + "。" + value + "' where medicineName='" + medicineName + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
            catch
            {

            }
        }

        public void updateMedicineNonInstructionTaboo(String medicineName)
        {
            try
            {
                String sql = "select a.name,a.value from BaiKeDetail a,MedicineNonInstruction b where (name like '%禁%' or name like '%忌%') and a.yaopin=b.medicineName and a.yaopin='" + medicineName + "'";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                if (dt.Rows.Count > 0)
                {
                    String name = dt.Rows[0][0].ToString();
                    String value = dt.Rows[0][1].ToString();
                    sql = "update MedicineNonInstruction set taboo='" + name + "。" + value + "' where medicineName='" + medicineName + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
            catch
            {

            }
        }
    }
}
