﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Threading.Tasks;
using System.Data.SqlClient;
using System.Data;
using YFDYFKnowledgeDiscovery.Common;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class ZhiDao
    {

        static SqlConnection conn = DBHelper.getConnection();

        public List<String> getName()
        {
            List<string> nameList = new List<string>();
            try
            {
                String sql = "select name from BaiDuZhiDao group by name";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                List<string> tempList = new List<string>();
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    tempList.Add(dt.Rows[i][0].ToString());
                }
                sql = "select medicinename from Medicine";
                DataTable dt2 = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt2.Rows.Count; i++)
                {
                    int flag = 0;
                    for (int j = 0; j < dt.Rows.Count; j++)
                    {
                        if (dt2.Rows[i][0].ToString().Equals(dt.Rows[j][0].ToString()))
                        {
                            flag = 1;
                            break;
                        }
                    }
                    if (flag == 0)
                    {
                        nameList.Add(dt2.Rows[i][0].ToString());
                    }
                }
            }
            catch
            {

            }
            return nameList;
        }

        public List<String> getUrl()
        {
            List<String> urlList = new List<string>();
            try
            {
                string sql = "select url from BaiDuZhiDao where LEN(url)>0 and question is null group by url";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    int index = dt.Rows[i][0].ToString().IndexOf("muzhi.baidu.com");
                    if (index == -1)
                    {
                        urlList.Add(dt.Rows[i][0].ToString());
                    }
                }
            }
            catch
            {

            }
            return urlList;
        }

        public void updateText(String url, String question, String answer)
        {
            String sql = "";
            try
            {
                if (answer.Length < 4000)
                {
                    sql = "update BaiDuZhiDao set answer='" + answer + "', question='" + question + "' where url='" + url + "'";
                }
                else
                {
                    sql = "update BaiDuZhiDao set answer='" + answer.Substring(0, 4000) + "', question='" + question + "' where url='" + url + "'";
                }
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public void insertBaiDuZhiDaoUrl(String name,String url)
        {
            try
            {
                string sql = "insert into BaiDuZhiDao(name,url) values('" + name + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public void insertBaiDuZhiDaoUrlText(List<string> diseaseUrlList)
        {
            string[] content = new string[diseaseUrlList.Count];
            for (int i = 0; i < diseaseUrlList.Count; i++)
            {
                content[i] = diseaseUrlList[i].ToString();
            }
            try
            {
                System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\diseaseurl.txt", content, Encoding.UTF8);
            }
            catch
            {

            }
        }

        public DataTable getBaiDuZhiDaoContext(string begin,string end)
        {
            try
            {
                string sql = "select name,url,question,answer from baiduzhidao where id>" + begin + " and id<" + end + " and len(answer)>0";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                return dt;
            }
            catch
            {
                return null;
            }
        }

        public void insertBaiDuZhiDaoDetail(string name, string url, string question, string questionDistription, string answer)
        {
            try
            {
                string sql = "insert into BaiDuZhiDaoDetail(name,url,question,questionDiscription,answer) values('" + name + "','" + url + "','" + question + "','" + questionDistription + "','" + answer + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }
    }
}
