﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace YFDYFKnowledgeDiscovery.Dao
{
    /// <summary>
    /// 中国健康网爬虫模型
    /// </summary>
    public class ZhongGuoJianKangWangModel
    {
        /// <summary>
        /// 疾病的名称
        /// </summary>
        public string Name { set; get; }
        /// <summary>
        /// 别名
        /// </summary>
        public string Alias { set; get; }
        /// <summary>
        /// 部位
        /// </summary>
        public string Position { set; get; }
        /// <summary>
        /// 科室
        /// </summary>
        public string Office { set; get; }
        /// <summary>
        /// 症状
        /// </summary>
        public string Symptom { set; get; }
        /// <summary>
        /// 基本描述
        /// </summary>
        public string BasicDescribe { set; get; }
        /// <summary>
        /// 病因
        /// </summary>
        public string Cause { set; get; }
        /// <summary>
        /// 症状体征
        /// </summary>
        public string SymptomsSigns { set; get; }
        /// <summary>
        /// 检查化验
        /// </summary>
        public string InspectionTesting{set;get;}
        /// <summary>
        /// 鉴别诊断
        /// </summary>
        public string Diagnosis { set; get; }
        /// <summary>
        /// 并发症
        /// </summary>
        public string Complication { set; get; }
        /// <summary>
        /// 预防保健
        /// </summary>
        public string PreventiveCare{set;get;}
        /// <summary>
        /// 治疗
        /// </summary>
        public string Treatment { set; get; }
    }
}
