﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Analysis;
using YFDYFKnowledgeDiscovery.Dao;
using YFDYFKnowledgeDiscovery.Semantics;
using YFDYFKnowledgeDiscovery.Spider;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void yaoJianJuButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Spider.YaoJianJu.YaoJianJu form = new Spider.YaoJianJu.YaoJianJu();
                form.Show();
            }
        }

        private void BaiDuBaiKeButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Spider.BaiDuBaiKe.BaiDuBaiKeForm form = new Spider.BaiDuBaiKe.BaiDuBaiKeForm();
                form.Show();
            }
        }

        private void ChaJiBingButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Spider.ChaJiBing.ChaJiBingForm form = new Spider.ChaJiBing.ChaJiBingForm();
                form.Show();
            }
        }

        private void JiXieFenCiButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                JiXieFenCiButton.Visible = false;
                //BaiKeSemantics baiKeSemantics = new BaiKeSemantics();
                //baiKeSemantics.saveBaiKeDetail();
                //baiKeSemantics.saveYaoPinChengFen();
                //baiKeSemantics.getComponentWord();
                //baiKeSemantics.saveYaoPinShiYingZheng();
                //baiKeSemantics.getSymptomWord();
                //baiKeSemantics.getPopulation();
                //ZhongGuoJianKangWangSemantics zhongGuoJianKangWangSematics = new ZhongGuoJianKangWangSemantics();
                //zhongGuoJianKangWangSematics.getBodyPositionWord();
                //zhongGuoJianKangWangSematics.getOfficeWord();
                //zhongGuoJianKangWangSematics.getDiseaseWord();
                //YaoPinSemantics yaoPinSemantics = new YaoPinSemantics();
                //yaoPinSemantics.getMedicineWord();
                //SymptomSemnatics symptomSemanatics = new SymptomSemnatics();
                //symptomSemanatics.SaveSymptomSemantics();

                //Dao.Symptom dao = new Dao.Symptom();
                //dao.SavaSymptomFromLinShi();

                //Semantics.HealthProductInstrument semantics = new HealthProductInstrument();
                //semantics.saveYaoPinShiYingZheng();
                //semantics.savePopulation();
                //semantics.saveComponent();
                //Semantics.MedicalInstrumentInstructionSemantics semantics = new MedicalInstrumentInstructionSemantics();
                //semantics.saveYaoPinShiYingZheng();

                //PopulationSemantics.GetTabooPopulation();
                //PopulationSemantics.GetSpecialPopulation();
                PopulationSemantics.InsertAnalysis();
                MessageBox.Show("运行结束");
            }
        }

        private void ZhongguojiankangWang_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Spider.ZhongGuoJianKangWang.ZhongGuoJianKangWangForm form = new Spider.ZhongGuoJianKangWang.ZhongGuoJianKangWangForm();
                form.Show();
            }
        }

        private void BaiDuZhiDaoForm_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Spider.BaiDuZhiDao.BaiDuZhiDaoForm form = new Spider.BaiDuZhiDao.BaiDuZhiDaoForm();
                form.Show();
            }
        }

        private void button_yaopintong_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Spider.YaoPinTongJianKang.YaoPinTongForm form = new Spider.YaoPinTongJianKang.YaoPinTongForm();
                form.Show();
            }
        }

        private void JD_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Spider.JDWebBrowserForm.JDWebBrowserForm form = new Spider.JDWebBrowserForm.JDWebBrowserForm();
                form.Show();
            }
        }

        private void ExportExcelButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Dao.ExcelDao.writeExcel("E:\\JixinZhang\\词条.xlsx");
                MessageBox.Show("运行结束");
            }
        }

        private void testButton_Click(object sender, EventArgs e)
        {
            if( MessageBox.Show( "确定执行吗？", "提示", MessageBoxButtons.YesNo ) == DialogResult.Yes )
            {
                List<string> list = Common.ExpressionSplitWordHelper.expressionSplitWord("我们本品为复方制剂，其组份为玛卡");
                MessageBox.Show("运行结束");
            }
        }

        private void button_TMall_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Spider.TMall.TMallWebBrowerForm form = new Spider.TMall.TMallWebBrowerForm();
                form.Show();
            }
        }

        private void YiHaoDianButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Spider.YiHaoDian.YiHaoDian form = new Spider.YiHaoDian.YiHaoDian();
                form.Show();
            }
        }

        private void button_Integration_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                DiseaseIntegration integration = new DiseaseIntegration();
                //integration.Disease_Body();
                //integration.Disease_Office();
                //integration.Disease_Symptom();
                //integration.Disease_Eat();
                integration.IntegrationDisease();
            }
        }

        private void MedicineInstructionButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Semantics.ShuoMingShuIntegration integration = new ShuoMingShuIntegration();
                //integration.insertDetail();
                //integration.insertMedicineInstruction();
                //integration.insertHealthProductInstruction();
                //integration.insertChineseMaterialInstruction();
                integration.insertMedicalInstrumentInstruction();
            }
        }

        private void symptomIntegrationBUtton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                //BaiKeSemantics baiKeSemantics = new BaiKeSemantics();
                //baiKeSemantics.saveYaoPinShiYingZheng();
                //baiKeSemantics.getSymptomWord();
                SymptomIntegration integration = new SymptomIntegration();
                //integration.insertDiseaseSymptom();
                integration.ReadExcel("E:\\JixinZhang\\症状.xlsx");
            }
        }

        private void button_DingXiangYuan_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                //Spider.DingXiangYuan.DingXiangYuanForm form = new Spider.DingXiangYuan.DingXiangYuanForm();

               Spider.DingXiangYuan.DingXiangYuanWebBrowerFrom form = new Spider.DingXiangYuan.DingXiangYuanWebBrowerFrom();
               form.Show();
            }
        }

        private void button_WordIntegration_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                //WordIntegration integration = new WordIntegration();
                //integration.InsertFoodWordBank();
                FoodIntegration integration = new FoodIntegration();
                integration.insertFood();
                MessageBox.Show("食物词库已整理!");
            }
        }

        private void button_Comment_Integration_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                CommentIntegration integration = new CommentIntegration();
                //integration.IntegrationJD();
                integration.IntegrationTMall();
                //integration.IntegrationYhd();
            }
        }

        private void statisticSpliWord_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                List<string> sentenceList = Common.StatisticSplitWordHelper.getSentence("MedicineInstruction", "mainfunction", null);
                List<string> wordList = Common.StatisticSplitWordHelper.getWordList(sentenceList);
                List<string> splitList = Common.StatisticSplitWordHelper.splitSentence(sentenceList, wordList, 0.003);
            }
        }

        private void button_Pattern_Integration_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                MedicineInstrument dao = new MedicineInstrument();
                dao.GetComponentFromLinshi();
                MessageBox.Show("运行完毕!");
            }
        }

        private void button_goodAndPop_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                GoodPopulationAnalysis.DealWithGoodAndPopulation();
                MessageBox.Show("运行完毕!");
            }
        }

        private void button_goodSymptom_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                MedicineSymptomAnalysis.DealWithMedicineSymptom();
                MessageBox.Show("运行完毕!");
            }
        }

        private void good_Component_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Good_Component good_c = new Good_Component();
                good_c.good_component3();
                MessageBox.Show("结束");
            }
        }

        private void SymptomInnerBtn_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Analysis.SymptomSymptomAnalysis analysis = new SymptomSymptomAnalysis();
                analysis.calculateSymptomReference();
            }
        }

        private void ComponentInnerBtn_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                
            }
        }

        private void MedicineNonInstructionBtn_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Semantics.NonInstructionMedicineIntegration integration = new NonInstructionMedicineIntegration();
                //integration.insertNonInstructionMedicine();
                //integration.updateNonInstructionMedicineDetail();
            }
        }

        private void ImportData_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                ImportDao dao = new ImportDao();
                //dao.importYFMedicine();
                //dao.handleYFMedicine();
                //dao.importDisease();
                //dao.importDiseaseContext();
                //dao.importSymptomContext();
                dao.handleYFMedicine2();
            }
        }

        private void ContentAnalysis_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                ContentAnalysis analysis = new ContentAnalysis();
                //analysis.diseasePreprocess();
                //analysis.diseaseGroupBy();
                //analysis.diseaseLevel();
                //analysis.diseaseContent();
                //analysis.populationPreprocess();
                //analysis.populationContent();
                //analysis.symptomPreprocess();
                //analysis.symptomInteraction();
            }
        }

        private void MedicineSymptomDiseaseStatistic_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                MedicineDiseaseSymptomAnalysis statistic = new MedicineDiseaseSymptomAnalysis();
                //statistic.statisticSymptomAndDiseasInMedicine();
                statistic.statisticSymptomAndDiseasInYFMedicine();
            }
        }

        private void ZhiDaoIntegration_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                BaiDuZhiDaoIntegration integration = new BaiDuZhiDaoIntegration();
                integration.insertBaiDuZhiDaoDetail();
            }
        }

        private void MedicineInteractionBtn_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                MedicineInteractionAnalysis analysis = new MedicineInteractionAnalysis();
                //analysis.saveUsefulSentence();
                //analysis.setMedicineClassify();
                analysis.setIndication();
            }
        }

        private void UsualNameBtn_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("确定执行吗？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Semantics.UsualName semantics = new UsualName();
                //semantics.insertDiseaseUsualName();
                semantics.insertSymptomUsualName();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //zhengzhuangAndMedincine.test();
            //zhengzhuangAndMedincine.test2();
            //zhengzhuangAndMedincine.test3();
            //zhengzhuangAndMedincine.test4();
            //zhengzhuangAndMedincine.test5();
            //zhengzhuangAndMedincine.test6();
            //zhengzhuangAndMedincine.test7();
            //zhengzhuangAndMedincine.test8();
            //zhengzhuangAndMedincine.test9();
            //zhengzhuangAndMedincine.test10();
            //zhengzhuangAndMedincine.test11();
            //zhengzhuangAndMedincine.test12();
            //zhengzhuangAndMedincine.test13();
            //zhengzhuangAndMedincine.test14();
            //zhengzhuangAndMedincine.test15();
            //zhengzhuangAndMedincine.test16();
            //zhengzhuangAndMedincine.test17();
            //zhengzhuangAndMedincine.test17();
            //zhengzhuangAndMedincine.test20();
            //zhengzhuangAndMedincine.test21();
            //zhengzhuangAndMedincine.test22();
            //zhengzhuangAndMedincine.test23();
            //zhengzhuangAndMedincine.test24();
            //zhengzhuangAndMedincine.test25();
            //zhengzhuangAndMedincine.test26();
            //zhengzhuangAndMedincine.test27();
            //zhengzhuangAndMedincine.test28();
            //zhengzhuangAndMedincine.test29();
            //zhengzhuangAndMedincine.test30();
            //zhengzhuangAndMedincine.test31();
            //zhengzhuangAndMedincine.test32();
            //zhengzhuangAndMedincine.test33();
            //zhengzhuangAndMedincine.test34();
            //zhengzhuangAndMedincine.test35();
            //zhengzhuangAndMedincine.test36();
            //zhengzhuangAndMedincine.test37();
            //zhengzhuangAndMedincine.test39();
            //zhengzhuangAndMedincine.test40();
            //zhengzhuangAndMedincine.test41();
            //zhengzhuangAndMedincine.test42();
            //zhengzhuangAndMedincine.test43();
            //zhengzhuangAndMedincine.test44();
            //zhengzhuangAndMedincine.test45();
            //zhengzhuangAndMedincine.test46();
            //zhengzhuangAndMedincine.test47();
            //zhengzhuangAndMedincine.test48();
            //zhengzhuangAndMedincine.test49();
            //zhengzhuangAndMedincine.test50();
            //zhengzhuangAndMedincine.test51();
            //zhengzhuangAndMedincine.test52();
            //zhengzhuangAndMedincine.test53();
            //zhengzhuangAndMedincine.test58();
            //zhengzhuangAndMedincine.test59();
            //zhengzhuangAndMedincine.test62();
            //zhengzhuangAndMedincine.test63();
            //zhengzhuangAndMedincine.test67();
            //zhengzhuangAndMedincine.test68();
            //zhengzhuangAndMedincine.test69();
            //zhengzhuangAndMedincine.test70();
            //zhengzhuangAndMedincine.test74();
            //zhengzhuangAndMedincine.test75();
            //zhengzhuangAndMedincine.test76();
            //zhengzhuangAndMedincine.test77();
            zhengzhuangAndMedincine.test93();

            //YFGoodInstruction instruction = new YFGoodInstruction();
            //instruction.insertYFGoodInstruction();
            //instruction.updateYFGoodInstruction();
            //instruction.updateYFGoodInstructionFromBaike();
            //instruction.ReadExcel("E:\\JixinZhang\\数据缺失的益丰商品.xlsx");
            //instruction.YFGoodIndicationDisease();
            //instruction.YFGoodIndicationSymptom();

            //Analysis.SymptonDiseasePredictionAnalysis.test();
            //Analysis.CommentEmotionClassification.commentEmotionFeatureExtraction();
            //Analysis.CommentEmotionClassification.classifyComments();
        }

        private void button_jiankewang_Click(object sender, EventArgs e)
        {
           Spider.jiankewang.jiankewangForm form = new Spider.jiankewang.jiankewangForm();
            form.Show();
        }

        private void button_yfdyf_Click(object sender, EventArgs e)
        {
            Spider.yfdyf.yfdyfWebBrowerForm form=new Spider.yfdyf.yfdyfWebBrowerForm();
            form.Show();
        }
    }
}
