﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class AnalysisSemantics
    {
        Dao.Analysis dao = new Dao.Analysis();

        public void saveBaiKeTitle()
        {
            DataTable dt = dao.getTextFromBaiKe();
            if (dt != null)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    String text = dt.Rows[i][0].ToString();
                    String[] values = text.Split(new string[] { "||||" }, StringSplitOptions.RemoveEmptyEntries);
                    for (int j = 0; j < values.Length; j++)
                    {
                        int index = values[j].IndexOf("||");
                        String title = "";
                        if (index != -1)
                        {
                            title = values[j].Substring(0, index);
                            title = title.Replace("&nbsp;", "").Replace(" ", "");
                            dao.insertTitleIntoAnalysis(title);
                        }
                    }
                }
            }
        }

        public void saveBaiKeTitleCommon()
        {
            DataTable dt = dao.getBaiKeTitleFromAnalysis();
            if (dt != null)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    String title = dt.Rows[i][0].ToString();
                    int count = Convert.ToInt32(dt.Rows[i][1].ToString());
                    if (count > 1)
                    {
                        dao.insertCommonTitleIntoAnalysis(title);
                    }
                }
            }
        }
    }
}
