﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class BaiDuZhiDaoIntegration
    {
        Dao.ZhiDao dao = new ZhiDao();
        public void insertBaiDuZhiDaoDetail()
        {
            for (int n = 0; n < 5000000; n = n + 50000)
            {
                string begin = n.ToString();
                string end = (n + 50000).ToString();
                DataTable dt = dao.getBaiDuZhiDaoContext(begin, end);
                if (dt == null || dt.Rows.Count == 0)
                {
                    continue;
                }
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i][0].ToString();
                    string url = dt.Rows[i][1].ToString();
                    string question = dt.Rows[i][2].ToString().Replace("_百度知道", "").Replace("_百度宝宝知道", "").Replace("_百度拇指医生", "");
                    string questionDiscription = "";
                    String[] values = question.Split(new string[] { "||" }, StringSplitOptions.RemoveEmptyEntries);
                    question = values[0];
                    if (values.Length > 1)
                    {
                        questionDiscription = values[1];
                    }
                    string answer = dt.Rows[i][3].ToString().Replace("【百度知道其他答案】", "【百度知道】");
                    values = answer.Split(new string[] { "||" }, StringSplitOptions.RemoveEmptyEntries);
                    string bestAnswer = "";
                    List<string> otherAnswers = new List<string>();
                    for (int j = 0; j < values.Length; j++)
                    {
                        int index = values[j].IndexOf("【最佳答案】");
                        if (index != -1)
                        {
                            bestAnswer = values[j];
                        }
                        otherAnswers.Add(values[j]);
                        dao.insertBaiDuZhiDaoDetail(name, url, question, questionDiscription, values[j]);
                    }
                }
            }
        }
    }
}
