﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;
using YFDYFKnowledgeDiscovery.Common;
using System.Windows.Forms;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    class MedicineNocomponent
    {
        Dao.MedicineInstruction Dao = new Dao.MedicineInstruction();

        //非说明书中没有化学字符的字段
        public void saveNameComponent()
        {
            List<string> auxiliaryVerbPrepositionList = Common.SemanticHelper.getAuxiliaryVerbPreposition();
            DataTable dt = Dao.getNOInstruction();

            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string component = dt.Rows[i][0].ToString();
                String[] value = component.Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);

                for (int j = 0; j < value.Length; j++)
                {
                    for (int auxnum = 0; auxnum < auxiliaryVerbPrepositionList.Count; auxnum++)
                    {
                        int index = value[j].LastIndexOf(auxiliaryVerbPrepositionList[auxnum]);

                        if (index != -1)
                        {
                            value[j] = value[j].Substring(index + auxiliaryVerbPrepositionList[auxnum].Length);
                        }                    
                    }
                    for (int othint = 0; othint < Common.SemanticHelper.other.Length; othint++)
                    {
                        value[j] = value[j].Replace(Common.SemanticHelper.other[othint], "");
                    }
                    Dao.insertNoCom(value[j]);

                }
            }
        }

        public void savecomponent()
        {
            List<string> auxiliaryVerbPrepositionList = Common.SemanticHelper.getAuxiliaryVerbPreposition();
            DataTable dt = Dao.getNOInstruction();
            List<string> split = new List<string>();
            List<string> value1 = new List<string>();


            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string original = dt.Rows[i][0].ToString();
                if (original.Contains("及其化学名称"))
                {
                    List<string> splitList = new List<string>();
                    splitList = ExpressionSplitWordHelper.expressionSplitWord(original);
                    if (splitList != null)
                    {
                        for (int j = 0; j < splitList.Count; j++)
                        {
                            if (splitList.Contains("辅料"))
                            {
                                //String[] original1 = splitList[j].Split(Common.SemanticHelper.conjection3, StringSplitOptions.RemoveEmptyEntries);
                                //value1.Add(original1[0]);
                                //value1.Add(original1[original1.Length - 1]);
                            }
                            else
                            {
                                //String[] original11 = splitList[j].Split(Common.SemanticHelper.conjection3, StringSplitOptions.RemoveEmptyEntries);
                                //value1.Add(original11[0]);
                            }
                            
                        }

                    }

                }

                else
                {
                    if (original.Contains("辅料"))
                    {
                        //String[] original2 = original.Split(Common.SemanticHelper.conjection3, StringSplitOptions.RemoveEmptyEntries);
                        //value1.Add(original2[0]);
                        //value1.Add(original2[original2.Length - 1]);
                    }
                    else
                    {
                        //String[] original22 = original.Split(Common.SemanticHelper.conjection3, StringSplitOptions.RemoveEmptyEntries);
                        //value1.Add(original22[0]);
                    }
          
                }
            }
            for (int k = 0; k < value1.Count; k++)
            {
                String[] value = value1[k].Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);

                for (int j = 0; j < value.Length; j++)
                {

                    for (int othint = 0; othint < Common.SemanticHelper.other.Length; othint++)
                    {
                        value[j] = value[j].Replace(Common.SemanticHelper.other[othint], "");
                    }
                    Dao.insertNoCom(value[j]);
                }

            }
        }

   
    }
}
