﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class NonInstructionMedicineIntegration
    {
        Dao.YaoPin dao = new YaoPin();

        public void insertNonInstructionMedicine()
        {
            DataTable dt = dao.getMedicineNonInstruction();
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String medicineName = dt.Rows[i][0].ToString();
                String approveNumber = dt.Rows[i][1].ToString();
                String enterprise = dt.Rows[i][2].ToString();
                String address = dt.Rows[i][3].ToString();
                String type = dt.Rows[i][4].ToString();
                String url = dt.Rows[i][5].ToString();
                dao.insertMedicineNonInstruction(medicineName, approveNumber, enterprise, address, type, url);
            }
        }

        public void updateNonInstructionMedicineDetail()
        {
            List<string> list = dao.getMedicineNonInstructionName();
            for (int i = 0; i < list.Count; i++)
            {
                dao.updateMedicineNonInstructionComponent(list[i].ToString());
            }
            for (int i = 0; i < list.Count; i++)
            {
                dao.updateMedicineNonInstructionIndication(list[i].ToString());
            }
            for (int i = 0; i < list.Count; i++)
            {
                dao.updateMedicineNonInstructionPopulation(list[i].ToString());
            }
            for (int i = 0; i < list.Count; i++)
            {
                dao.updateMedicineNonInstructionTaboo(list[i].ToString());
            }
        }
    }
}
