﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;
using Excel = Microsoft.Office.Interop.Excel;
using System.Data.SqlClient;
using System.Data;
using System.Reflection;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class SymptomIntegration
    {
        static SqlConnection conn = DBHelper.getConnection();
        Dao.Analysis dao = new Dao.Analysis();

        public void insertDiseaseSymptom()
        {
            try
            {
                string sql = "select Symptom from Disease_Symptom group by symptom";
                var result = DBHelper.ExecuteWithReset(sql, conn);
                if (result != null && result.Rows.Count >= 1)
                {
                    for (int i = 0; i < result.Rows.Count; i++)
                    {
                        string symptom = result.Rows[i][0].ToString();
                        sql = "insert into analysis(text,name) values('" + symptom + "','symptom')";
                        DBHelper.ExecuteNoResult(sql, conn);
                    }
                }
                List<string> symptomList = new List<string>();
                symptomList = dao.getValueGroup("symptom");
                for (int i = 0; i < symptomList.Count; i++)
                {
                    dao.insertValueGroup("symptom", "symptomName", symptomList[i].ToString());
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }

        public void ReadExcel(String filePathName)
        {
            Excel.Application xapp = new Excel.Application();
            try
            {
                Excel.Workbook xbook = xapp.Workbooks._Open(filePathName, Missing.Value, Missing.Value,
                                        Missing.Value, Missing.Value, Missing.Value, Missing.Value, Missing.Value,
                                        Missing.Value, Missing.Value, Missing.Value, Missing.Value, Missing.Value);
                Excel.Worksheet xsheet = (Excel.Worksheet)xbook.Sheets[1];
                //for (int i = 2; i <= 10795; i++)
                //{
                //    Excel.Range rng = xsheet.get_Range("C"+i.ToString(), Missing.Value);
                //    String symptom = rng.Text;
                //    if (symptom != null && symptom.Equals("") == false)
                //    {
                //        String sql = "insert into analysis(text,name) values('" + symptom + "','symptom')";
                //        DBHelper.ExecuteNoResult(sql, conn);
                //    }
                //}
                //xapp.Workbooks.Close();
                //List<string> symptomList = new List<string>();
                //symptomList = dao.getValueGroup("symptom");
                //for (int i = 0; i < symptomList.Count; i++)
                //{
                //    dao.insertValueGroup("symptom", "symptomName", symptomList[i].ToString());
                //}
                //for (int i = 2; i <= 1000; i++)
                //{
                //    Excel.Range rng = xsheet.get_Range("H" + i.ToString(), Missing.Value);
                //    String population = rng.Text;
                //    if (population != null && population.Equals("") == false)
                //    {
                //        String sql = "insert into analysis(text,name) values('" + population + "','population')";
                //        DBHelper.ExecuteNoResult(sql, conn);
                //    }
                //}
                //xapp.Workbooks.Close();
                //List<string> populationList = new List<string>();
                //populationList = dao.getValueGroup("population");
                //for (int i = 0; i < populationList.Count; i++)
                //{
                //    dao.insertValueGroup("population", "populationName", populationList[i].ToString());
                //}
                //for (int i = 2; i <= 14000; i++)
                //{
                //    Excel.Range rng = xsheet.get_Range("A" + i.ToString(), Missing.Value);
                //    String component = rng.Text;
                //    if (component != null && component.Equals("") == false)
                //    {
                //        String sql = "insert into analysis(text,name) values('" + component + "','component')";
                //        DBHelper.ExecuteNoResult(sql, conn);
                //    }
                //}
                //xapp.Workbooks.Close();
                //List<string> componentList = new List<string>();
                //componentList = dao.getValueGroup("component");
                //for (int i = 0; i < componentList.Count; i++)
                //{
                //    dao.insertValueGroup("component", "componentName", componentList[i].ToString());
                //}
                //for (int i = 2; i <= 41645; i++)
                //{
                //    Excel.Range rng = xsheet.get_Range("A" + i.ToString(), Missing.Value);
                //    String symptom = rng.Text;
                //    if (symptom != null && symptom.Equals("") == false)
                //    {
                //        String sql = "insert into analysis(text,name) values('" + symptom + "','symptom')";
                //        DBHelper.ExecuteNoResult(sql, conn);
                //    }
                //}
                //xapp.Workbooks.Close();
                //List<string> symptomList = new List<string>();
                //symptomList = dao.getValueGroup("symptom");
                //for (int i = 0; i < symptomList.Count; i++)
                //{
                //    dao.insertValueGroup("symptom", "symptomName", symptomList[i].ToString());
                //}
            }
            catch
            {
                xapp.Workbooks.Close();
            }
        }
    }
}
