﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class WordIntegration
    {
        static SqlConnection conn = DBHelper.getConnection();
        
        /// <summary>
        /// 插入食物词库
        /// </summary>
        public void InsertFoodWordBank()
        {
            try
            {
                string sql = "select distinct(Eat_Food) from Disease_Eat"; 
                var result = DBHelper.ExecuteWithReset(sql, conn);
                if (result != null && result.Rows.Count >= 1)
                {
                    for (int i = 0; i < result.Rows.Count; i++)
                    {
                        string food = result.Rows[i][0].ToString();
                        sql = "insert into analysis(text,name) values('" + food + "','food')";
                        DBHelper.ExecuteNoResult(sql, conn);
                    }
                }

                sql = "select distinct(NotEat_Food) from Disease_NotEat";
                result = DBHelper.ExecuteWithReset(sql, conn);
                if (result != null && result.Rows.Count >= 1)
                {
                    for (int i = 0; i < result.Rows.Count; i++)
                    {
                        string food = result.Rows[i][0].ToString();
                        sql = "insert into analysis(text,name) values('" + food + "','food')";
                        DBHelper.ExecuteNoResult(sql, conn);
                    }
                }
               
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
    }
}
