﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class YaoPinSemantics
    {
        Dao.YaoPin dao = new Dao.YaoPin();

        public void splitYaoPinData()
        {
            DataTable dt = dao.getYaoPinData();
            if (dt == null)
            {
                return;
            }
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String id = dt.Rows[i][0].ToString();
                String text = dt.Rows[i][1].ToString();
                String[] values = text.Split(new string[] { "||" }, StringSplitOptions.RemoveEmptyEntries);
                String piZhunWenHao = "";
                String chanPinMingCheng = "";
                String yingWenMingCheng = "";
                String shangPinMingCheng = "";
                String jiXing = "";
                String guiGe = "";
                String shengChanDanWei = "";
                String shengChanDiZhi = "";
                String chanPinLeiBie = "";
                String yuanPiZhunWenHao = "";
                String piZhunRiQi = "";
                String yaoPinBenWeiMa = "";
                String yaoPinBenWeiMaBeiZhu = "";
                String xiangGuanShuJuKuChaXun = "";
                for (int j = 0; j < values.Length; j++)
                {
                    if (values[j].Equals("批准文号") == true && values[j + 1].Equals("产品名称") == false)
                    {
                        piZhunWenHao = values[j + 1];
                    }
                    else if (values[j].Equals("产品名称") == true && values[j + 1].Equals("英文名称") == false)
                    {
                        chanPinMingCheng = values[j + 1]; ;
                    }
                    else if (values[j].Equals("英文名称") == true && values[j + 1].Equals("商品名") == false)
                    {
                        yingWenMingCheng = values[j + 1];
                    }
                    else if (values[j].Equals("商品名") == true && values[j + 1].Equals("剂型") == false)
                    {
                        shangPinMingCheng = values[j + 1];
                    }
                    else if (values[j].Equals("剂型") == true && values[j + 1].Equals("规格") == false)
                    {
                        jiXing = values[j + 1];
                    }
                    else if (values[j].Equals("规格") == true && values[j + 1].Equals("生产单位") == false)
                    {
                        guiGe = values[j + 1];
                    }
                    else if (values[j].Equals("生产单位") == true && values[j + 1].Equals("生产地址") == false)
                    {
                        shengChanDanWei = values[j + 1];
                    }
                    else if (values[j].Equals("生产地址") == true && values[j + 1].Equals("产品类别") == false)
                    {
                        shengChanDiZhi = values[j + 1];
                    }
                    else if (values[j].Equals("产品类别") == true && values[j + 1].Equals("原批准文号") == false)
                    {
                        chanPinLeiBie = values[j + 1];
                    }
                    else if (values[j].Equals("原批准文号") == true && values[j + 1].Equals("批准日期") == false)
                    {
                        yuanPiZhunWenHao = values[j + 1];
                    }
                    else if (values[j].Equals("批准日期") == true && values[j + 1].Equals("药品本位码") == false)
                    {
                        piZhunRiQi = values[j + 1];
                    }
                    else if (values[j].Equals("药品本位码") == true && values[j + 1].Equals("药品本位码备注") == false)
                    {
                        yaoPinBenWeiMa = values[j + 1];
                    }
                    else if (values[j].Equals("药品本位码备注") == true && values[j + 1].Equals("相关数据库查询") == false)
                    {
                        yaoPinBenWeiMaBeiZhu = values[j + 1];
                    }
                    else if (values[j].Equals("相关数据库查询") == true && values[j + 1].Equals("注") == false)
                    {
                        xiangGuanShuJuKuChaXun = values[j + 1];
                    }
                }
                String sql = "update YaoJianJu set piZhunWenHao='" + piZhunWenHao + "', ";
                sql += "chanPinMingCheng='" + chanPinMingCheng + "', ";
                sql += "yingWenMingCheng='" + yingWenMingCheng + "', ";
                sql += "shangPinMingCheng='" + shangPinMingCheng + "', ";
                sql += "jiXing='" + jiXing + "', ";
                sql += "guiGe='" + guiGe + "', ";
                sql += "shengChanDanWei='" + shengChanDanWei + "', ";
                sql += "shengChanDiZhi='" + shengChanDiZhi + "', ";
                sql += "chanPinLeiBie='" + chanPinLeiBie + "', ";
                sql += "yuanPiZhunWenHao='" + yuanPiZhunWenHao + "', ";
                sql += "piZhunRiQi='" + piZhunRiQi + "', ";
                sql += "yaoPinBenWeiMa='" + yaoPinBenWeiMa + "', ";
                sql += "yaoPinBenWeiMaBeiZhu='" + yaoPinBenWeiMaBeiZhu + "', ";
                sql += "xiangGuanShuJuKuChaXun='" + xiangGuanShuJuKuChaXun + "' ";
                sql += "where id=" + id + "";
                dao.upDateYaoPinSplitData(sql);
            }
        }

        public void getMedicineWord()
        {
            List<string> medicineList = dao.getValue("YaoJianJu", "name");
            String[] splitValues = new String[] { " ", "," };
            for (int i = 0; i < medicineList.Count; i++)
            {
                String[] values = medicineList[i].Split(splitValues, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < values.Length; j++)
                {
                    dao.insertValue("medicine", values[j]);
                }
            }
            List<string> medicineGroupList = dao.getValueGroup("medicine");
            for (int i = 0; i < medicineGroupList.Count; i++)
            {
                dao.insertValueGroup("medicine", "medicineName", medicineGroupList[i].ToString());
            }
        }
    }
}
