﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class ZhongGuoJianKangWangSemantics
    {
        Dao.ZhongGuoJianKangWang dao = new Dao.ZhongGuoJianKangWang();

        public void getBodyPositionWord()
        {
            List<string> positionList = dao.getValue("ZhongGuoJianKangWang","position");
            String[] splitValues = new String[] { " ", "," };
            for (int i = 0; i < positionList.Count; i++)
            {
                String[] values = positionList[i].Split(splitValues, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < values.Length; j++)
                {
                    String[] replaceValues = { "部", "部位" };
                    String value = values[j];
                    for (int k = 0; k < replaceValues.Length; k++)
                    {
                        value = value.Replace(replaceValues[k], "");
                        dao.insertValue("position",value);
                    }
                }
            }
            List<string> positionGroupList = dao.getValueGroup("position");
            for (int i = 0; i < positionGroupList.Count; i++)
            {
                dao.insertValueGroup("body","positionName",positionGroupList[i].ToString());
            }
        }

        public void getOfficeWord()
        {
            List<string> officeList = dao.getValue("ZhongGuoJianKangWang", "office");
            String[] splitValues = new String[] { " ", "," };
            for (int i = 0; i < officeList.Count; i++)
            {
                String[] values = officeList[i].Split(splitValues, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < values.Length; j++)
                {
                    dao.insertValue("office", values[j]);
                }
            }
            List<string> officeGroupList = dao.getValueGroup("office");
            for (int i = 0; i < officeGroupList.Count; i++)
            {
                dao.insertValueGroup("office", "officeName", officeGroupList[i].ToString());
            }
        }

        public void getDiseaseWord()
        {
            List<string> officeList = dao.getValue("ZhongGuoJianKangWang", "name");
            officeList = dao.getValue("ChaJiBing", "name", officeList);
            String[] splitValues = new String[] { " ", "," };
            for (int i = 0; i < officeList.Count; i++)
            {
                String[] values = officeList[i].Split(splitValues, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < values.Length; j++)
                {
                    dao.insertValue("disease", values[j]);
                }
            }
            List<string> officeGroupList = dao.getValueGroup("disease");
            for (int i = 0; i < officeGroupList.Count; i++)
            {
                dao.insertValueGroup("disease", "diseaseName", officeGroupList[i].ToString());
            }
        }
    }
}
