﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using HtmlAgilityPack;
using System.Data.SqlClient;
using System.Data;
using System.Threading.Tasks;

namespace YFDYFKnowledgeDiscovery.Spider.BaiDuBaiKe
{
    public class BaiDuBaiKe
    {

        public BaiDuBaiKe()
        {

        }

        Dao.BaiKe model = new Dao.BaiKe();

        public void getUrlAddress()
        {
            List<String> nameList = model.getName();
            List<string> link = new List<string>();
            for (int i = 0; i < nameList.Count; i++)
            {
                HtmlDocument document = HTMLHelper.getHTMLContentByURL("http://baike.baidu.com/search?word=" + nameList[i].ToString() + "&pn=0&rn=0&enc=utf8", Encoding.UTF8);
                if (document == null)
                {
                    continue;
                }
                HtmlNodeCollection nodeCollection = HTMLHelper.getHTMLNodeByXpath("//div[@class='searchResult']//a[@class='result-title'][1]", document);
                if (nodeCollection != null)
                {
                    if (nodeCollection[0].InnerText.Trim().Replace("_百度百科", "").Equals(nameList[i].ToString()) == true)
                    {
                        link.Add(nodeCollection[0].GetAttributeValue("href", ""));
                        //model.insertBaikeUrl(nodeCollection[0].GetAttributeValue("href", ""));
                    }
                }
            }
        }

        public void getContent()
        {
            List<String> urlList = model.getUrl();
            for (int i = 0; i < urlList.Count; i++)
            {
                HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlList[i], Encoding.UTF8);
                HtmlNodeCollection nodeCollection1 = HTMLHelper.getHTMLNodeByXpath("//span[@class='title-text']", document);
                HtmlNodeCollection nodeCollection2 = HTMLHelper.getHTMLNodeByXpath("//div[@class='para']", document);
                if (nodeCollection1 != null && nodeCollection2 != null)
                {
                    String str = "";
                    for (int j = 0; j < nodeCollection1.Count && j < nodeCollection2.Count; j++)
                    {
                        str += nodeCollection1[j].InnerText.Replace("\n", "").Replace("'", "");
                        str += "||";
                        str += nodeCollection2[j].InnerText.Replace("\n", "").Replace("'", "");
                        str += "||||";
                    }
                    //model.updateBaikeText(urlList[i].ToString(), str);
                }
            }
        }

        public void getName()
        {
            DataTable dt = model.getUrlAndId();
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                HtmlDocument document = HTMLHelper.getHTMLContentByURL(dt.Rows[i][0].ToString(), Encoding.UTF8);
                HtmlNodeCollection nodeCollection = HTMLHelper.getHTMLNodeByXpath("//title", document);
                if (nodeCollection != null)
                {
                    String name = nodeCollection[0].InnerText.Trim().Replace("_百度百科", "");
                    int id = Convert.ToInt32(dt.Rows[i][1].ToString());
                    model.updateName(name, id);
                }
            }
        }
    }
}
