﻿using HtmlAgilityPack;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Spider.DingXiangYuan
{
    public partial class DingXiangYuanForm : Form
    {
        public DingXiangYuanForm()
        {
            InitializeComponent();
        }
        int id = 1175;
        List<string> medicineList = new List<string>();
        List<string> medicineUrlList = new List<string>();
        Dao.DingXiangYuan model = new Dao.DingXiangYuan();

        private void button_GetYaoPin_Click(object sender, EventArgs e)
        {
          
            List<string> urlList = model.GetMedicineList();
            medicineList = urlList;
            content.Text = "地址获取完成";
        }

        private void startButtonTrigger_Tick(object sender, EventArgs e)
        {
            //button1_Click(button1, null);
            button_getDetail_Click(button_getDetail, null);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (id < 10000)  //到1175
            {
                string url = "http://drugs.dxy.cn/search/drug.htm?keyword=" + medicineList[id];
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url, Encoding.UTF8);
                HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//ul[@class='list']//h3/a", document);
                if (document != null)
                {
                    if (nodelist != null)  //有多条
                    {
                        var productNameNode = nodelist[0];
                        var productName = productNameNode.InnerText.FilterStr().Split('-')[0].Trim();
                        if (productName.Contains(medicineList[id]))
                        {
                            var href = productNameNode.GetAttributeValue("href", "");
                            model.InsertLinShiUrl(href, medicineList[id]);
                        }
                        else
                        {

                        }
                    }
                    else
                    {
                        HtmlNodeCollection resultCount = HTMLHelper.getHTMLNodeByXpath("//div[@class='fr f12 result-status']//span[2]", document);
                        if (resultCount != null)
                        {

                        }
                        else
                        {
                            model.InsertLinShiUrl(url, medicineList[id]);
                        }
                    }
                }
                content.Text = medicineList[id] + "爬取完成";
                id++;
                startButtonTrigger.Start();
            }
            else
            {
                content.Text = "全部爬取完成";
                startButtonTrigger.Stop();
                return;
            }
        }

        private void button_getUrlList_Click(object sender, EventArgs e)
        {
            medicineUrlList = model.GetMedicineUrlList();
            content.Text = "地址获取完成";
        }

        private void button_getDetail_Click(object sender, EventArgs e)
        {
            //string url1 = medicineUrlList[id];
            //HTMLHelper.getDocumentByHttpRequest(url1);
            //return;

            List<string> dtList = new List<string>(); //存储的dt
            List<string> ddList = new List<string>(); //存储不包含详情的dd
            if (id < medicineUrlList.Count)  //到1175
            {
                string url = medicineUrlList[id];
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url, Encoding.UTF8);
                HtmlNodeCollection nodeTitle = HTMLHelper.getHTMLNodeByXpath("//div[@class='fl commend']", document);
                HtmlNodeCollection nodeAttributeList = HTMLHelper.getHTMLNodeByXpath("//dl//dd", document);
                HtmlNodeCollection nodeTitleList = HTMLHelper.getHTMLNodeByXpath("//dl//dt", document);
                if (document != null)
                {
                    if (nodeAttributeList != null && nodeTitleList!=null)
                    {
                        for (int i = 0; i < nodeAttributeList.Count; i++)
                        {
                            var text = nodeAttributeList[i].InnerText.FilterStr();
                            if (text.Contains("该信息登录才能查看，请"))
                            {
                                continue;
                            }
                            else
                            {
                                ddList.Add(text);
                            }
                        }
                        for (int i = 0; i < nodeTitleList.Count; i++)
                        {
                            var text = nodeTitleList[i].InnerText.FilterStr();
                            dtList.Add(text);
                        }
                        for (int i = 0; i < nodeTitleList.Count; i++)
                        {
                            model.InsertDingXiangYuanDetail(dtList[i], ddList[i], url);
                        }
                        model.UpdateFlagByUrl(url);
                    }
                }
                content.Text = url + "爬取完成";
                id++;
                startButtonTrigger.Start();
            }
            else
            {
                startButtonTrigger.Stop();
                return;
            }
        }
    }
}
