﻿using HtmlAgilityPack;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Dao;

namespace YFDYFKnowledgeDiscovery.Spider.JD
{
    public partial class JDForm : Form
    {
        private Dao.JD model = new Dao.JD();

        public JDForm()
        {
            InitializeComponent();
        }
        
        private void button_JD_Click(object sender, EventArgs e)
        {

        }
        /// <summary>
        /// 获取京东商品列表
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            List<string> nameList = new List<string>();
            for (int i = 1; i <= 22; i++)
            {
                string url = "http://search.jd.com/s_new.php?keyword=%E7%9B%8A%E4%B8%B0%E5%A4%A7%E8%8D%AF%E6%88%BF&enc=utf-8&page=" + i.ToString();
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url, Encoding.UTF8);
                HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='p-name p-name-type-2']/a", document); //获取共多少条 中药材每页是8个
                if (document != null)
                {
                    if (nodelist != null)
                    {
                        foreach (var node in nodelist)
                        {
                            var title = node.GetAttributeValue("title", "");
                            var href = node.GetAttributeValue("href", "");
                            //插入数据库
                            model.InsertJDShangPinUrl(href, title);
                        }
                    }
                }
            }
        }
    }
}
