﻿using HtmlAgilityPack;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Dao;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Spider.jiankewang
{
    public partial class jiankewangForm : Form
    {
        int productPageIndex = 1;

        YFDYFKnowledgeDiscovery.Dao.jiankewang model = new Dao.jiankewang();
        public jiankewangForm()
        {
            InitializeComponent();
        }
        int fenlei = 1;
        int totalpage = 0;
        string productType = "";
        private void getProdURL_Click(object sender, EventArgs e)
        {
            if (fenlei <= 9)
            {
                //string url = "http://www.jianke.com/list-01-0-1-0-1-0-0-0-0-0.html"; //中西药品
                //string url = "http://www.jianke.com/list-02-0-1-0-1-0-0-0-0-0.html";  //保健养生
                //string url = "http://www.jianke.com/list-03-0-1-0-1-0-0-0-0-0.html";  //时尚美妆
                //string url = "http://www.jianke.com/list-04-0-1-0-1-0-0-0-0-0.html";  //成人用品

                string urlpart1 = "http://www.jianke.com/list-0" + fenlei;
                string urlpart2 = "-0-1-0-1-0-0-0-0-0.html";
                string url = urlpart1 + urlpart2;

                if (productPageIndex == 1)
                {
                    HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url, Encoding.UTF8);
                    HtmlNodeCollection totalPageNode = HTMLHelper.getHTMLNodeByXpath("//span[@id='goto_page_total_pages']/strong", document);
                    totalpage = Int32.Parse(totalPageNode[0].InnerText);
                    HtmlNodeCollection fenleiNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='menu-con']/a", document);
                    productType = fenleiNode[0].InnerText;
                }

                if (productPageIndex <= totalpage)
                {
                    //url = "http://www.jianke.com/list-01-0-" + productPageIndex + "-0-1-0-0-0-0-0.html"; //中西药品
                    //url = "http://www.jianke.com/list-02-0-" + productPageIndex + "-0-1-0-0-0-0-0.html";  //保健养生
                    //url = "http://www.jianke.com/list-03-0-" + productPageIndex + "-0-1-0-0-0-0-0.html";  //时尚美妆
                    //url = "http://www.jianke.com/list-04-0-" + productPageIndex + "-0-1-0-0-0-0-0.html";  //成人用品
                    url = urlpart1 + "-0-" + productPageIndex + "-0-1-0-0-0-0-0.html";
                    HtmlAgilityPack.HtmlDocument document2 = HTMLHelper.getHTMLContentByURL(url, Encoding.UTF8);
                    if (document2 != null)
                    {
                        HtmlNodeCollection productUrlNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='pro-botxt']/p//a", document2);

                        for (int i = 0; i < productUrlNode.Count; i++)
                        {
                            string producturl = productUrlNode[i].GetAttributeValue("href", "");
                            model.InsertProductUrl(producturl, productType);
                        }
                    }
                    productPageIndex++;
                    timer_getDetail.Start();
                    urlAddress.Text = url;
                }
                else
                {
                    timer_getDetail.Stop();
                    //MessageBox.Show(urlpart1 + "Url获取完成！");
                    productPageIndex = 1;
                    totalpage = 0;
                    fenlei++;
                    timer_getDetail.Start();
                }
            }
            else
            {
                MessageBox.Show("已爬取所有分类");
            }
        }
        int urlid = 0;
        private void getProdDetail_Click(object sender, EventArgs e)
        {
            if (urlid < urlAddressList.Count)
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlAddressList[urlid], Encoding.UTF8);

                //HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL("http://baojian.jianke.com/product/471735.html", Encoding.UTF8);
                HtmlNodeCollection titleNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='widet']/h1", document);
                HtmlNodeCollection commonNameNode = HTMLHelper.getHTMLNodeByXpath("//dl[@class='assort tongyong']/dd", document);
                HtmlNodeCollection productNode = HTMLHelper.getHTMLNodeByXpath("//dl[@class='assort']/dd", document);
                HtmlNodeCollection shuomingshuNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='bigfont']//p[@style='display: block']", document);
                string productName="";
                string commonName = "";
                string productNum = "";
                string approveNum = "";
                string shuoming = "";
                if (titleNode != null && commonNameNode != null && productNode != null && shuomingshuNode != null)
                {
                     productName = titleNode[0].InnerText.FilterStr();
                     commonName = commonNameNode[0].InnerText.FilterStr();
                     productNum = productNode[0].InnerText.FilterStr();
                     approveNum = productNode[1].InnerText.FilterStr().Replace("点击验真假", "");
                   
                    for (int i = 0; i < shuomingshuNode.Count; i++)
                    {
                        shuoming += shuomingshuNode[i].InnerText.FilterStr() + "@";
                    }
                    model.updateByUrl(productName, commonName, productNum, approveNum, shuoming, urlAddressList[urlid]);
                }
                else
                {
                    titleNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='dcnt_title']//b", document);
                    commonNameNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='pdtif fr']/ul/li[2]//p", document);
                    
                    shuomingshuNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='pmr_txt']//tr", document);

                    if (titleNode != null && commonNameNode != null&& shuomingshuNode != null)
                    {
                        productName = titleNode[0].InnerText.FilterStr();
                        commonName = commonNameNode[0].InnerText.FilterStr().Replace("通用名称：","");
                        productNum = commonNameNode[1].InnerText.FilterStr().Replace("产品编号：", "");
                        approveNum = commonNameNode[2].InnerText.FilterStr().Replace("点击验真假", "").Replace("批准文号：","");
                        for (int i = 0; i < shuomingshuNode.Count; i++)
                        {
                            shuoming += shuomingshuNode[i].InnerText.FilterStr() + "@";
                        }
                        model.updateByUrl(productName, commonName, productNum, approveNum, shuoming, urlAddressList[urlid]);
                    }
                    else
                    {

                        titleNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='d_text_box fl col_7b']//h1", document);
                        commonNameNode = HTMLHelper.getHTMLNodeByXpath("//ul[@class='d-ul']//li", document);
                        shuomingshuNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='bigfont']//p[@style='display: block']", document);
                        if (titleNode != null && commonNameNode != null && shuomingshuNode != null)
                        {
                            productName = titleNode[0].InnerText.FilterStr();
                            commonName = commonNameNode[0].InnerText.FilterStr().Replace("通用名称：", "");
                            productNum = commonNameNode[1].InnerText.FilterStr().Replace("产品编号：", "");
                            approveNum = commonNameNode[2].InnerText.FilterStr().Replace("点击验真假", "").Replace("批准文号：", "");
                            for (int i = 0; i < shuomingshuNode.Count; i++)
                            {
                                shuoming += shuomingshuNode[i].InnerText.FilterStr() + "@";
                            }
                            model.updateByUrl(productName, commonName, productNum, approveNum, shuoming, urlAddressList[urlid]);
                        }
                        else
                        {
                            titleNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='proinfo']//h1", document);
                            commonNameNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='proinfo']/ul//li", document);
                            shuomingshuNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='bigfont']//p[@style='display: block']", document);
                            if (titleNode != null && commonNameNode != null && shuomingshuNode != null)
                            {
                                productName = titleNode[0].InnerText.FilterStr();
                                commonName = commonNameNode[0].InnerText.FilterStr().Replace("【通用名称】：", "");
                                productNum = commonNameNode[1].InnerText.FilterStr().Replace("【产品编号】：", "");
                                approveNum = commonNameNode[2].InnerText.FilterStr().Replace("点击验真假", "").Replace("【批准文号】：", "");
                                for (int i = 0; i < shuomingshuNode.Count; i++)
                                {
                                    shuoming += shuomingshuNode[i].InnerText.FilterStr() + "@";
                                }
                                model.updateByUrl(productName, commonName, productNum, approveNum, shuoming, urlAddressList[urlid]);
                            }
                            else
                            {
                                titleNode = HTMLHelper.getHTMLNodeByXpath("//h1[@class='f17 col-39']", document);
                                commonNameNode = HTMLHelper.getHTMLNodeByXpath("//ul[@class='d-ul']//li", document);
                                shuomingshuNode = HTMLHelper.getHTMLNodeByXpath("//div[@class='bigfont']//p[@style='display: block']", document);
                                if (titleNode != null && commonNameNode != null && shuomingshuNode != null)
                                {
                                    productName = titleNode[0].InnerText.FilterStr();
                                    commonName = commonNameNode[0].InnerText.FilterStr().Replace("通用名称：", "");
                                    productNum = commonNameNode[1].InnerText.FilterStr().Replace("产品编号：", "");
                                    approveNum = commonNameNode[2].InnerText.FilterStr().Replace("点击验真假", "").Replace("批准文号：", "");
                                    for (int i = 0; i < shuomingshuNode.Count; i++)
                                    {
                                        shuoming += shuomingshuNode[i].InnerText.FilterStr() + "@";
                                    }
                                    model.updateByUrl(productName, commonName, productNum, approveNum, shuoming, urlAddressList[urlid]);
                                }
                                else
                                {
                                    titleNode = HTMLHelper.getHTMLNodeByXpath("//h1[@class='proname_aq f18 color40']", document);
                                    commonNameNode = HTMLHelper.getHTMLNodeByXpath("//h5[@class='txt1_aq f14 color7b']", document);
                                    productNode = HTMLHelper.getHTMLNodeByXpath("//h5[@class='txt2_aq f14 color7b']", document);
                                    shuomingshuNode = HTMLHelper.getHTMLNodeByXpath("//dl[@class='f14 color39 sms_aq bd1']//dt", document);
                                    if (titleNode != null && commonNameNode != null && shuomingshuNode != null)
                                    {
                                        productName = titleNode[0].InnerText.FilterStr();
                                        commonName = commonNameNode[0].InnerText.FilterStr().Replace("通用名称：", "");
                                        productNum = productNode[0].InnerText.FilterStr().Replace("产品编号：", "");
                                        //approveNum = commonNameNode[2].InnerText.FilterStr().Replace("点击验真假", "").Replace("批准文号：", "");
                                        for (int i = 0; i < shuomingshuNode.Count; i++)
                                        {
                                            shuoming += shuomingshuNode[i].InnerText.FilterStr() + "@";
                                        }
                                        model.updateByUrl(productName, commonName, productNum, approveNum, shuoming, urlAddressList[urlid]);
                                    }
                                }
                            }
                        }
                    }
                }
               
                timer_getDetail.Start();
                urlAddress.Text = urlAddressList[urlid];
                urlid++;
            }
            else
            {
                timer_getDetail.Stop();
            }
        }

        private void timer_getDetail_Tick(object sender, EventArgs e)
        {
            //getProdURL_Click(getProdURL, null);
            getProdDetail_Click(getProdDetail, null);
        }
        List<string> urlAddressList;
        private void butto_getFromDb_Click(object sender, EventArgs e)
        {
            urlAddressList = model.GetProductUrlList();
            urlAddress.Text = "获取完成";
        }
    }
}
