﻿using HtmlAgilityPack;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Spider.yfdyf
{
    public partial class yfdyfWebBrowerForm : Form
    {
        public yfdyfWebBrowerForm()
        {
            InitializeComponent();
            //this.webBrowser1.ScriptErrorsSuppressed = true;
        }
        YFDYFKnowledgeDiscovery.Dao.yfdyf model = new Dao.yfdyf();
        int pageindex = 1;
        int totalpage = 0;
        private void button_getUrl_Click(object sender, EventArgs e)
        {
            string urlpart1="http://www.yfdyf.com/search-result--b-j-p-1-"+pageindex;
            string urlpart2 = ".html";
            string url = urlpart1 + urlpart2;
            string baseUrl = "http://www.yfdyf.com";

            if (pageindex == 1)
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url, Encoding.UTF8);
                HtmlNodeCollection totalPageNode = HTMLHelper.getHTMLNodeByXpath("//a[@class='pagernum'][last()]", document);
                totalpage = Int32.Parse(totalPageNode[0].InnerText);
            }

            if (pageindex <= totalpage)
            {
                HtmlAgilityPack.HtmlDocument document2 = HTMLHelper.getHTMLContentByURL(url, Encoding.UTF8);
                if (document2 != null)
                {
                    HtmlNodeCollection productUrlNode = HTMLHelper.getHTMLNodeByXpath("//div[@id='gallery-grid-list']//div[@class='goodpic']/a", document2);

                    for (int i = 0; i < productUrlNode.Count; i++)
                    {
                        string producturl = baseUrl + productUrlNode[i].GetAttributeValue("href", "");
                        model.InsertProductUrl(producturl);
                    }
                }
                pageindex++;
                timer_getdata.Start();
                urlAddress.Text = url;
            }
            else
            {
                timer_getdata.Stop();
                //MessageBox.Show(urlpart1 + "Url获取完成！");
                timer_getdata.Start();
            }
        }
        List<string> urlAddressList;
        private void button_getUrlFromDB_Click(object sender, EventArgs e)
        {
            urlAddressList = model.GetProductUrlList();
            urlAddress.Text = "获取完成";
        }

        int urlid = 0;
        private void button_getDetail_Click(object sender, EventArgs e)
        {
            //HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL("http://www.yfdyf.com/product-3075.html", Encoding.UTF8);
            //HtmlNodeCollection productUrlNode = HTMLHelper.getHTMLNodeByXpath("//div[class='instruction-tit']", document);


            //return;
            Uri uri = new Uri(urlAddressList[urlid]);

            webBrowser1.Url = uri;
            urlAddress.Text = uri.ToString();

            if (urlid > urlAddressList.Count())
            {
                timer_getdata.Stop();
            }
            else
            {
                timer_getdata.Start();
                urlid++;
            }
        }

        private void timer_getdata_Tick(object sender, EventArgs e)
        {
            //button_getUrl_Click(button_getUrl, null);
            button_getDetail_Click(button_getDetail, null);
        }

        private void webBrowser1_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            string productName = "";
            string approveNum = "";
            string bianma = "";
            HtmlElementCollection elements = webBrowser1.Document.GetElementsByTagName("p");
            for(int i=0;i<elements.Count;i++)
            {
                if (elements[i].OuterHtml.ToString().Contains("pro_identify_p1"))
                {
                    productName = elements[i].InnerText.FilterStr();
                    continue;
                }
                if(elements[i].InnerText.Contains("批准文号"))
                {
                    approveNum = elements[i].InnerText.FilterStr();
                    continue;
                }
            }
            HtmlElementCollection elements_li = webBrowser1.Document.GetElementsByTagName("li");
            for (int j = 0; j < elements_li.Count; j++)
            {
                var aaa = elements_li[j].OuterHtml.ToString();
                if (!string.IsNullOrEmpty(elements_li[j].InnerText) && elements_li[j].InnerText.Contains("编码："))
                {
                    bianma = elements_li[j].InnerText.FilterStr();
                    break;
                }
            }
           
            HtmlElementCollection elements_AttrParent = webBrowser1.Document.GetElementsByTagName("dl");
            for (int kk = 0; kk < elements_AttrParent.Count; kk++)
            {
                var aaaaa = elements_AttrParent[kk].InnerText;
                if (aaaaa.Contains("药品名称"))
                {
                }
            }

            string content = webBrowser1.Document.Body.InnerHtml;
            urlAddress.Text = content;


            //HtmlElementCollection elements_Attr = webBrowser1.Document.GetElementsByTagName("dl");
            //for(int k=0;k<elements_Attr.Count;k++)
            //{
            //    var attrName=elements_Attr[k].GetElementsByTagName("dt")[0].InnerText.FilterStr();
            //    var attrValue=elements_Attr[k].GetElementsByTagName("dd")[0].InnerText.FilterStr();
            //    if (!string.IsNullOrEmpty(attrName) && !string.IsNullOrEmpty(attrValue))
            //    {
            //        model.insertKeyValue(productName, approveNum, bianma, attrName, attrValue);
            //    }
                
            //}
            //model.updateByUrl(productName, urlAddressList[urlid]);
            //urlAddress.Text = urlAddressList[urlid] + "爬取完成";
        }
    }
}
