﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Analysis
{
   public class Good_Component
    {
       //连接数据库
        static SqlConnection conn = DBHelper.getConnection();

       //MedicineInstruction
        public void good_component()
        {

            //获取成分
            DataTable dt = null;
            string sql = "select componentName from Component";
            dt = DBHelper.ExecuteWithReset(sql, conn);

            //获取药品信息
            DataTable datat = null;
            sql = "select name,component,approveNumber,type,url from MedicineInstruction ";
            datat = DBHelper.ExecuteWithReset(sql,conn);

            for (int i = 0; i < datat.Rows.Count; i++)
            {
                string name = datat.Rows[i]["name"].ToString();
                string component = datat.Rows[i]["component"].ToString();
                string approveNumber = datat.Rows[i]["approveNumber"].ToString();
                string type = datat.Rows[i]["type"].ToString();
                string url = datat.Rows[i]["url"].ToString();

                for (int j = 0; j < dt.Rows.Count; j++)
                {
                    string componentName = dt.Rows[j][0].ToString();

                    if (component.Contains(componentName))
                    {
                        string sq = "insert into Good_Component(goodName,component,approveNumber,type,url) values ('" + name + "','" + componentName + "','" + approveNumber + "','" + type + "','" + url + "')";
                        int result = DBHelper.ExecuteNoResult(sq, conn);
                    }
                }

            }
        }

       //ChineseMedicineMaterialInstruction
        public void good_component1()
        {

            //获取成分
            DataTable dt = null;
            string sql = "select componentName from Component";
            dt = DBHelper.ExecuteWithReset(sql, conn);

            //获取药品信息
            DataTable datat = null;
            sql = "select name,component,type,url from ChineseMedicineMaterialInstruction ";
            datat = DBHelper.ExecuteWithReset(sql, conn);

            for (int i = 0; i < datat.Rows.Count; i++)
            {
                string name = datat.Rows[i]["name"].ToString();
                string component = datat.Rows[i]["component"].ToString();
                string type = datat.Rows[i]["type"].ToString();
                string url = datat.Rows[i]["url"].ToString();

                for (int j = 0; j < dt.Rows.Count; j++)
                {
                    string componentName = dt.Rows[j][0].ToString();

                    if (component.Contains(componentName))
                    {
                        string sq = "insert into Good_Component(goodName,component,type,url) values ('" + name + "','" + componentName + "','" + type + "','" + url + "')";
                        int result = DBHelper.ExecuteNoResult(sq, conn);
                    }
                }

            }
        }

       //HealthProducInstruction
        public void good_component2()
        {

            //获取成分
            DataTable dt = null;
            string sql = "select componentName from Component";
            dt = DBHelper.ExecuteWithReset(sql, conn);

            //获取药品信息
            DataTable datat = null;
            sql = "select name,material,approveNumber,type,url from HealthProductInstruction ";
            datat = DBHelper.ExecuteWithReset(sql, conn);

            for (int i = 0; i < datat.Rows.Count; i++)
            {
                string name = datat.Rows[i]["name"].ToString();
                string material = datat.Rows[i]["material"].ToString();
                string approveNumber = datat.Rows[i]["approveNumber"].ToString();
                string type = datat.Rows[i]["type"].ToString();
                string url = datat.Rows[i]["url"].ToString();

                for (int j = 0; j < dt.Rows.Count; j++)
                {
                    string componentName = dt.Rows[j][0].ToString();

                    if (material.Contains(componentName))
                    {
                        string sq = "insert into Good_Component(goodName,component,approveNumber,type,url) values ('" + name + "','" + componentName + "','" + approveNumber + "','" + type + "','" + url + "')";
                        int result = DBHelper.ExecuteNoResult(sq, conn);
                    }
                }

            }
        }

       //MedicineInstrumentInstruction
        public void good_component3()
        {

            //获取成分
            DataTable dt = null;
            string sql = "select componentName from Component";
            dt = DBHelper.ExecuteWithReset(sql, conn);

            //获取药品信息
            DataTable datat = null;
            sql = "select name,performanceComponent,approveNumber,type,url from MedicalInstrumentInstruction ";
            datat = DBHelper.ExecuteWithReset(sql, conn);

            for (int i = 0; i < datat.Rows.Count; i++)
            {
                string name = datat.Rows[i]["name"].ToString();
                string performanceComponent = datat.Rows[i]["performanceComponent"].ToString();
                string approveNumber = datat.Rows[i]["approveNumber"].ToString();
                string type = datat.Rows[i]["type"].ToString();
                string url = datat.Rows[i]["url"].ToString();

                for (int j = 0; j < dt.Rows.Count; j++)
                {
                    string componentName = dt.Rows[j][0].ToString();

                    if (performanceComponent.Contains(componentName))
                    {
                        string sq = "insert into Good_Component(goodName,component,approveNumber,type,url) values ('" + name + "','" + componentName + "','" + approveNumber + "','" + type + "','" + url + "')";
                        int result = DBHelper.ExecuteNoResult(sq, conn);
                    }
                }

            }
        }

    }
}
