﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.IO;
using System.Net;

/// <summary>
/// FileDonwload 的摘要说明
/// </summary>
public class FileDonwload
{
	public static string downloadFile(String url,String name,String type)
    {
        String filename="";
        if (type == ".xls") 
        {
            filename = System.AppDomain.CurrentDomain.BaseDirectory + "document\\excel\\" + name + type + "\\";

        }
        else if (type == ".doc") 
        {
            filename = System.AppDomain.CurrentDomain.BaseDirectory + "document\\word\\" + name + type + "\\";
        }
         String path = filename.Remove(filename.Length - 1);
        int k = url.LastIndexOf("/");
        string a = url.Substring(k+1, url.Length - k-1);
        String FileName = name+type;
        int i = 1;
        bool flag = false;
            try
            {
                if (!Directory.Exists(path))
                {
                    Directory.CreateDirectory(path);
                }
                while (File.Exists(filename + FileName)) 
                {
                    String[] b =  new String[10];
                    b = FileName.Split(new Char[]{'.'});
                    FileName = b[0] + i + type;
                    i++;
                }
                using (FileStream fs = new FileStream(filename + FileName, FileMode.Create, FileAccess.Write))
                {
                    //创建请求
                    HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
                    //接收响应
                    HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                    //输出流
                    Stream responseStream = response.GetResponseStream();
                    byte[] bufferBytes = new byte[1000000];//缓冲字节数组
                    int bytesRead = -1;
                    while ((bytesRead = responseStream.Read(bufferBytes, 0, bufferBytes.Length)) > 0)
                    {
                        fs.Write(bufferBytes, 0, bytesRead);
                    }
                    if (fs.Length > 0)
                    {
                        flag = true;
                    }
                    //关闭写入
                    fs.Flush();
                    fs.Close();
                    return filename + FileName;
                }
                
            }
            catch (Exception exp)
            {
                //返回错误消息
                return "出错:"+exp.StackTrace;
            }
        
    }
}