﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace YFDYFKnowledgeDiscovery.Common
{
    public class SemanticHelper
    {
        public static String[] auxiliaryAdverb = { "可以", "可", "能够", "能", "尤其", "同时", "常" };

        public static String[] timeAdverb = { };

        public static String[] spaceAdverb = { };

        public static String[] verb = { "对","供", "控制", "治疗","主治", "单治疗","治","用作", "用", "防治", "防止", "治疗", "适用", "使用"
                                          , "含有", "含","伴有","有", "具有", "预防", "是","对","制止","改善","利于","缓解","改善","缓和","作为"
                                          ,"提高","减轻","降低","引起","促使","包括","促进","伴继发","伴发","诱发","抵抗","抗","类似","见","发生","解除","除"
                                          ,"补充","增加","增强","调节","保护","抑制","辅助","有助","测量","检查","检测","处理" };

        public static String[] conjection = { "、", ",", "，", ".", "。", " ", "：", ":", "；", ";", "以及", "及", "/"
                                                , "和", "或", "与", "并", "合并","(",")","又" };

        public static String[] conjection2 = { "、", ",", "，", ".", "。", " ", "：", ":", "；", ";", "以及", "及", "/"
                                                , "和", "或", "与", "并", "合并","(",")","又","的" };

        public static String[] adjective = {  };

        public static String[] preposition = { "于", "在", "的" };

        public static String[] other = { "各种","各型","多种", "如", "等", "情况下", "大小", "形状", "①", "②", "③", "④", "⑤","⑥","⑦","⑧","妇科", "儿科"
                                           , "内科", "泌尿科", "皮肤科", "眼科", "1．", "2．", "3．", "4．", "5．", "6．","．","·","?","包括","【","化学成分"
                                           , "7．", "8．", "9．", "10．", "11．", "12．", "@", "I]", "（）", "()",")", "±","]","[","辨证","辨证为","︰","－"
                                           ,"1","2","3","4","5","6","7","8","9","0","I","II","III","●","表现为","临床","可于治疗","尚","）"
                                           , "毫克", "毫升", "等味", " ", "本品", "苗医", "中医", "其他", "其它", "医院", "无改善","治疗"
                                           , "以下", "作用", "科", "由","因","（1）","（2）","（3）","（4）","（5）","（6）","（7）","近年来于"
                                           ,"（8）","（9）","(1)","(2)","(3)","(4)","(5)","(6)","(7)","(8)","(9)", "的","该药物"
                                           ,"均有效","有效","见上述证候者","患者","者","加强","进行期","期间","此","某些","症见","病人"
                                           ,"所致","均有明显疗效","有明显疗效","有辅助保护功能","有保护功能","有","保护功能","保健功能"
                                           ,"药物","用药","药","某些","也有一定疗效","也","亦","功效","功能","症状"," ","\"","调节","用","主"
                                           ,"病例" };

        public static List<String> getAuxiliaryVerbPreposition()
        {
            List<string> list = new List<string>();
            for (int auxiliaryNum = 0; auxiliaryNum < Common.SemanticHelper.auxiliaryAdverb.Length; auxiliaryNum++)
            {
                for (int verbNum = 0; verbNum < Common.SemanticHelper.verb.Length; verbNum++)
                {
                    for (int prepositionNum = 0; prepositionNum < Common.SemanticHelper.preposition.Length; prepositionNum++)
                    {
                        list.Add(verb[verbNum] + preposition[prepositionNum]);
                        list.Add(auxiliaryAdverb[auxiliaryNum] + verb[verbNum] + preposition[prepositionNum]);
                    }
                    list.Add(verb[verbNum]);
                    list.Add(auxiliaryAdverb[auxiliaryNum] + verb[verbNum]);
                }
                list.Add(auxiliaryAdverb[auxiliaryNum]);
            }
            return list;
        }

        /// <summary>
        /// 处理成对出现的字符串
        /// </summary>
        /// <param name="str">原始字符串</param>
        /// <param name="startStr">起始字符串</param>
        /// <param name="endStr">结束字符串</param>
        /// <returns></returns>
        public static string DealWithCPSymobol(string str,string startStr,string endStr)
        {
            int startIndex = str.IndexOf(startStr);
            if (startIndex == -1)
                return str;
            else
            {
                int endIndex = str.IndexOf(endStr);
                if (endIndex == -1)
                    return str;
                else
                {
                    string str1 = str.Substring(0, startIndex);
                    string str2 = str.Substring(endIndex + 1);
                    return str1 + str2;
                }
            }
        }
    }
}
