﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using HtmlAgilityPack;
using System.Text;
using System.Net;
using System.IO;
using System.Drawing;
using mshtml;

/// <summary>
/// ExtractPicture 的摘要说明
/// </summary>
public class VerificationCodeHelper
{

    Bitmap No0 = null;
    Bitmap No1 = null;
    Bitmap No2 = null;
    Bitmap No3 = null;
    Bitmap No4 = null;
    Bitmap No5 = null;
    Bitmap No6 = null;
    Bitmap No7 = null;
    Bitmap No8 = null;
    Bitmap No9 = null;

    public VerificationCodeHelper()
	{
        initPictureData();
	}

    public void getPictureSrc(String picUrl)
    {
        if (!String.IsNullOrEmpty(picUrl))
        {
            //WebClient webClient = new WebClient();
            //webClient.DownloadFile(picUrl, "D:\\img.png");
            //MemoryStream ms = new MemoryStream(webClient.DownloadData(picUrl)); 
            //Image img = Image.FromStream(ms);
            //img.Save("D:\\img.png");

            //HttpWebRequest request = (HttpWebRequest)WebRequest.Create(picUrl);
            //request.Timeout = 20000;
            //request.ServicePoint.ConnectionLimit = 100;
            //request.ReadWriteTimeout = 30000;
            //request.Method = "GET";
            //HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            //if (response.StatusCode != HttpStatusCode.OK)
            //    return;
            //Stream resStream = response.GetResponseStream();
            //Image img = new Bitmap(resStream);
        }
    }

    public void initPictureData()
    {
        for (int i = 0; i < 10; i++)
        {
            FileStream fs = File.OpenRead(System.AppDomain.CurrentDomain.BaseDirectory + "NumberImage\\"+i.ToString()+".png"); //OpenRead
            int filelength = 0;
            filelength = (int)fs.Length; //获得文件长度 
            Byte[] image = new Byte[filelength]; //建立一个字节数组 
            fs.Read(image, 0, filelength); //按字节流读取 
            System.Drawing.Image result = System.Drawing.Image.FromStream(fs);
            fs.Close();
            if (i == 0)
            {
                No0 = new Bitmap(result);
            }
            else if (i == 1)
            {
                No1 = new Bitmap(result);
            }
            else if (i == 2)
            {
                No2 = new Bitmap(result);
            }
            else if (i == 3)
            {
                No3 = new Bitmap(result);
            }
            else if (i == 4)
            {
                No4 = new Bitmap(result);
            }
            else if (i == 5)
            {
                No5 = new Bitmap(result);
            }
            else if (i == 6)
            {
                No6 = new Bitmap(result);
            }
            else if (i == 7)
            {
                No7 = new Bitmap(result);
            }
            else if (i == 8)
            {
                No8 = new Bitmap(result);
            }
            else if (i == 9)
            {
                No9 = new Bitmap(result);
            }
        }
    }

    public String getPictureData()
    {
        FileStream fs = File.OpenRead(System.AppDomain.CurrentDomain.BaseDirectory + "image\\17.png"); //OpenRead
        int filelength = 0;
        filelength = (int)fs.Length; //获得文件长度 
        Byte[] image = new Byte[filelength]; //建立一个字节数组 
        fs.Read(image, 0, filelength); //按字节流读取 
        System.Drawing.Image result = System.Drawing.Image.FromStream(fs);
        fs.Close();
        Bitmap bit = new Bitmap(result);
        Bitmap bit2 = new Bitmap(bit.Width, bit.Height);
        int start1 = 0, start2 = 0, start3 = 0, start4 = 0;
        int end1 = 0, end2 = 0, end3 = 0, end4 = 0;
        int turn = 0;
        for (int i = 0; i < bit.Width; i++)
        {
            int flag = 0;
            for (int j = 0; j < bit.Height; j++)
            {
                Color pixelColor = bit.GetPixel(i, j);
                int avg = (pixelColor.R + pixelColor.G + pixelColor.B) / 3;
                if (avg < 128)
                {
                    flag = 1;
                    if (turn == 0)
                    {
                        if (start1 == 0)
                        {
                            start1 = i;
                            turn = 1;
                        }
                        else if (start2 == 0)
                        {
                            start2 = i;
                            turn = 1;
                        }
                        else if (start3 == 0)
                        {
                            start3 = i;
                            turn = 1;
                        }
                        else if (start4 == 0)
                        {
                            start4 = i;
                            turn = 1;
                        }
                    }
                    else
                    {
                        if (start2 == 0)
                        {
                            end1 = i;
                        }
                        else if (start3 == 0)
                        {
                            end2 = i;
                        }
                        else if (start4 == 0)
                        {
                            end3 = i;
                        }
                        else
                        {
                            end4 = i;
                        }
                    }
                    Color pixelGray = Color.FromArgb(255, 255, 255);
                    bit2.SetPixel(i, j, pixelGray);
                }
                else
                {
                    Color pixelGray = Color.FromArgb(0, 0, 0);
                    bit2.SetPixel(i, j, pixelGray);
                }
            }
            if (flag == 0)
            {
                turn = 0;
            }
        }
        //bit2.Save("E:\\gray.png");
        Bitmap splitBit1 = new Bitmap(end1 - start1 + 1, bit.Height);
        for (int i = start1; i <= end1; i++)
        {
            for (int j = 0; j < bit.Height; j++)
            {
                Color pixelColor = bit2.GetPixel(i, j);
                splitBit1.SetPixel(i - start1, j, pixelColor);
            }
        }
        String number1 = findNumber(splitBit1).ToString();
        Bitmap splitBit2 = new Bitmap(end2 - start2 + 1, bit.Height);
        for (int i = start2; i <= end2; i++)
        {
            for (int j = 0; j < bit.Height; j++)
            {
                Color pixelColor = bit2.GetPixel(i, j);
                splitBit2.SetPixel(i - start2, j, pixelColor);
            }
        }
        String number2 = findNumber(splitBit2).ToString();
        Bitmap splitBit3 = new Bitmap(end3 - start3 + 1, bit.Height);
        for (int i = start3; i <= end3; i++)
        {
            for (int j = 0; j < bit.Height; j++)
            {
                Color pixelColor = bit2.GetPixel(i, j);
                splitBit3.SetPixel(i - start3, j, pixelColor);
            }
        }
        String number3 = findNumber(splitBit3).ToString();
        Bitmap splitBit4 = new Bitmap(end4 - start4 + 1, bit.Height);
        for (int i = start4; i <= end4; i++)
        {
            for (int j = 0; j < bit.Height; j++)
            {
                Color pixelColor = bit2.GetPixel(i, j);
                splitBit4.SetPixel(i - start4, j, pixelColor);
            }
        }
        String number4 = findNumber(splitBit4).ToString();
        return number1 + number2 + number3 + number4;
    }

    public float pictureMatch(Bitmap bit1,Bitmap bit2)
    {
        int sum = 0;
        for (int i = 0; i < bit1.Width && i < bit2.Width; i++)
        {
            for (int j = 0; j < bit1.Height && j < bit2.Height; j++)
            {
                Color pixelColor1 = bit1.GetPixel(i, j);
                Color pixelColor2 = bit2.GetPixel(i, j);
                if (pixelColor1.R == pixelColor2.R)
                {
                    sum++;
                }
            }
        }
        float similar = (float)sum/(bit1.Width*bit1.Height);
        return similar;
    }

    public int findNumber(Bitmap bit)
    {
        float[] similar = new float[10];
        similar[0] = pictureMatch(bit, No0);
        similar[1] = pictureMatch(bit, No1);
        similar[2] = pictureMatch(bit, No2);
        similar[3] = pictureMatch(bit, No3);
        similar[4] = pictureMatch(bit, No4);
        similar[5] = pictureMatch(bit, No5);
        similar[6] = pictureMatch(bit, No6);
        similar[7] = pictureMatch(bit, No7);
        similar[8] = pictureMatch(bit, No8);
        similar[9] = pictureMatch(bit, No9);
        float max=similar[0];
        int maxi = 0;
        for (int i = 1; i < 10; i++)
        {
            if (max < similar[i])
            {
                max = similar[i];
                maxi = i;
            }
        }
        return maxi;
    }
}