﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Threading.Tasks;
using System.Data.SqlClient;
using System.Data;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class Analysis
    {

        static SqlConnection conn = DBHelper.getConnection();

        public DataTable getTextFromBaiKe()
        {
            DataTable dt = null;
            try
            {
                string sql = "select text from Baike where LEN(text)>0";
                dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
            return dt;
        }

        public int insertTitleIntoAnalysis(String title)
        {
            string sql = "insert into analysis(baiketitle) values('" + title + "')";
            int result = DBHelper.ExecuteNoResult(sql, conn);
            return result;
        }

        public int insertCommonTitleIntoAnalysis(String commonTitle)
        {
            string sql = "insert into analysis(baiketitlecommon) values('" + commonTitle + "')";
            int result = DBHelper.ExecuteNoResult(sql, conn);
            return result;
        }

        public DataTable getBaiKeTitleFromAnalysis()
        {
            DataTable dt = null;
            try
            {
                string sql = "select baiketitle,COUNT(1) from analysis group by baiketitle";
                dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
            return dt;
        }

        public List<String> getValueGroup(String valueName)
        {
            List<String> valueList = new List<string>();
            try
            {
                string sql = "select text from analysis where name='" + valueName + "' group by text";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }

        public void insertValueGroup(String tableName, String valueName, String text)
        {
            try
            {
                string sql = "insert into " + tableName + "(" + valueName + ") values('" + text + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }
    }
}
