﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Threading.Tasks;
using System.Data.SqlClient;
using System.Data;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class BaiKe
    {

        static SqlConnection conn = DBHelper.getConnection();

        public List<String> getName()
        {
            List<String> nameList = new List<string>();
            try
            {
                string sql = "select goodname from kdgoods group by goodname";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    nameList.Add(dt.Rows[i][0].ToString());
                }
                sql = "select diseasename from kddisease group by diseasename";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    nameList.Add(dt.Rows[i][0].ToString());
                }
                sql = "select symptomname from kdsymptom group by symptomname";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    nameList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return nameList;
        }

        public void updateName(String name,int id)
        {
            try
            {
                string sql = "update BaiKe set name='" + name + "' where id="+id;
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public List<String> getUrl()
        {
            List<String> urlList = new List<string>();
            try
            {
                string sql = "select url from BaiKe where LEN(url)>0";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }

        public DataTable getUrlAndId()
        {
            DataTable dt = null;
            try
            {
                string sql = "select url,id from BaiKe where LEN(url)>0 and id>916";
                dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
            return dt;
        }

        public void insertBaikeUrl(String url)
        {
            try
            {
                string sql = "insert into BaiKe(url) values('" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public void updateBaikeText(String url, String text, String name)
        {
            String sql = "";
            try
            {
                if (text.Length < 8000)
                {
                    sql = "update BaiKe set text='" + text + "', name='"+name+"' where url='" + url + "'";
                }
                else 
                {
                    sql = "update BaiKe set text='" + text.Substring(0, 8000) + "', name='" + name + "' where url='" + url + "'";
                }
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public DataTable getTextFromBaiKe()
        {
            DataTable dt = null;
            try
            {
                string sql = "select text,name from Baike where LEN(text)>0 and id>916";
                dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
            return dt;
        }

        public void insertYaoPinDetail(String title, String value, String name)
        {
            string sql = "insert into BaiKeDetail(name,value,yaopin,isStructure) values('" + title + "','" + value + "','" + name + "',0)";
            int result = DBHelper.ExecuteNoResult(sql, conn);
        }

        public DataTable getYaoPinChengFenFromBaiKeDetail()
        {
            DataTable dt = null;
            try
            {
                string sql = "select value,yaopin from baikedetail where (name='成分' or name='成份') and YaoPin in (select name from yaojianju where chanpinleibie='中药')";
                dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
            return dt;
        }

        public void insertYaoPinChengFen(String subject, String value, String discription, String yaopin)
        {
            string sql = "insert into YaoPinChengFen(subject,value,discription,yaopin) values('" + subject + "','" + value + "','" + discription + "','" + yaopin + "')";
            int result = DBHelper.ExecuteNoResult(sql, conn);
        }

        public DataTable getYaoPinShiYingZhengFromBaiKeDetail()
        {
            DataTable dt = null;
            try
            {
                string sql = "select value,yaopin from baikedetail where name like '%适%症%' or name like '%症%适%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
            return dt;
        }

        public DataTable getYaoPinGongNengFromBaiKeDetail()
        {
            DataTable dt = null;
            try
            {
                string sql = "select value,yaopin from baikedetail where name like '%功能%主治%' or name like '%主治%功能%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
            return dt;
        }

        public void insertYaoPinShiYingZheng(String subject, String value, String discription, String yaopin)
        {
            string sql = "insert into YaoPinShiYingZheng(subject,value,discription,yaopin) values('" + subject + "','" + value + "','" + discription + "','" + yaopin + "')";
            int result = DBHelper.ExecuteNoResult(sql, conn);
        }

        public List<String> getValue(String tableName, String valueName)
        {
            List<String> valueList = new List<string>();
            try
            {
                string sql = "select " + valueName + " from " + tableName + " where LEN(" + valueName + ")>0";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }

        public List<String> getValue(String tableName, String valueName,String whereStr)
        {
            List<String> valueList = new List<string>();
            try
            {
                string sql = "";
                if (whereStr != null)
                {
                    sql = "select " + valueName + " from " + tableName + " " + whereStr;
                }
                else
                {
                    sql = "select " + valueName + " from " + tableName;
                }
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }

        public List<String> getValue(String tableName, String valueName, List<String> list)
        {
            List<String> valueList = list;
            try
            {
                string sql = "select " + valueName + " from " + tableName + " where LEN(" + valueName + ")>0";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }

        public void insertValue(String valueName, String text)
        {
            try
            {
                string sql = "insert into analysis(text,name) values('" + text + "','" + valueName + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public List<String> getValueGroup(String valueName)
        {
            List<String> valueList = new List<string>();
            try
            {
                string sql = "select text from analysis where name='" + valueName + "' group by text";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }

        public void insertValueGroup(String tableName, String valueName, String text)
        {
            try
            {
                string sql = "insert into " + tableName + "(" + valueName + ") values('" + text + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public void insertBaikeDiseaseUrlText(List<string> diseaseUrlList)
        {
            string[] content = new string[diseaseUrlList.Count];
            for (int i = 0; i < diseaseUrlList.Count; i++)
            {
                content[i] = diseaseUrlList[i].ToString();
            }
            try
            {
                System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\diseaseurl.txt", content, Encoding.UTF8);
            }
            catch
            {

            }
        }

        public void insertBaikeSymptomUrlText(List<string> SymptomUrlList)
        {
            string[] content = new string[SymptomUrlList.Count];
            for (int i = 0; i < SymptomUrlList.Count; i++)
            {
                content[i] = SymptomUrlList[i].ToString();
            }
            try
            {
                System.IO.File.WriteAllLines(@"E:\\JixinZhang\\益丰大药房知识库\\YFDYFKnowledgeDiscovery\\Doc\\symptomUrl.txt", content, Encoding.UTF8);
            }
            catch
            {

            }
        }

        public List<String> getDiseaseUrlText()
        {
            List<String> urlList = new List<string>();
            try
            {
                string[] lines = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\diseaseurl.txt", Encoding.Default);
                for (int i = 0; i < lines.Length; i++)
                {
                    int index = lines[i].IndexOf("http");
                    urlList.Add(lines[i].Substring(index).ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }

        public List<String> getSymptomUrlText()
        {
            List<String> urlList = new List<string>();
            try
            {
                string[] lines = System.IO.File.ReadAllLines(@"E:\\JixinZhang\\益丰大药房知识库\\YFDYFKnowledgeDiscovery\\Doc\\symptomUrl.txt", Encoding.Default);
                for (int i = 0; i < lines.Length; i++)
                {
                    int index = lines[i].IndexOf("http");
                    urlList.Add(lines[i].Substring(index).ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }
    }
}
