﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class JD
    {
        //获取数据库连接
        static SqlConnection conn = DBHelper.getConnection();

        /// <summary>
        /// 插入商品的地址
        /// </summary>
        /// <param name="url">商品的地址</param>
        public void InsertJDShangPinUrl(string url, string name)
        {
            try
            {
                string sql = "insert into LinShiJD(url,name) values('" + url + "','" + name + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }
        /// <summary>
        /// 获取商品的链接
        /// </summary>
        public List<string> getProductUrl()
        {
            List<String> urlList = new List<string>();
            try
            {
                string sql = "select url from LinShiJD where flag is null group by url";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }
        /// <summary>
        /// 插入商品的评论、评分、价格、商品名称
        /// </summary>
        /// <param name="name"></param>
        /// <param name="price"></param>
        /// <param name="comment"></param>
        /// <param name="comment_star"></param>
        public void InsertJDProductCommnent(string name, double price, string comment, int comment_star)
        {
            try
            {
                string sql = "insert into JD(name,price,comment,comment_star) values('" + name + "','" + price + "','" + comment + "','" + comment_star + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }
        /// <summary>
        /// 根据url更新该url的访问状态
        /// </summary>
        /// <param name="url"></param>
        public void UpdateFlagByUrl(string url)
        {
            try
            {
                string sql = "update LinShiJD set flag=1 where url='" + url + "'";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }

        /// <summary>
        /// 插入评价JsonURL
        /// </summary>
        /// <param name="name"></param>
        /// <param name="price"></param>
        /// <param name="comment"></param>
        /// <param name="comment_star"></param>
        public void InsertJsonUrl(string name, string url)
        {
            try
            {
                string sql = "insert into JD(name,url) values('" + name + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }
        /// <summary>
        /// 根据url地址获取Json数据
        /// </summary>
        /// <param name="url">获取json数据的URL地址</param>
        /// <param name="comment">url对应的数据</param>
        public void UpdateJsonDataByUrl(string url, string comment)
        {
            try
            {
                string sql = "update JD set comment='" + comment + "' where url='" + url + "'";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }

        /// <summary>
        /// 获取商品评价Json数据的链接
        /// </summary>
        public List<string> getCommentJsonUrl()
        {
            List<String> urlList = new List<string>();
            try
            {
                string sql = "select url from JD where comment is null and id>500";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }
       
    }
}
