﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class JiBing
    {
        //获取数据库连接
        static SqlConnection conn = DBHelper.getConnection();

        /// <summary>
        /// 插入疾病的名称和地址
        /// </summary>
        /// <param name="title">疾病的名称</param>
        /// <param name="url">疾病的地址</param>
        public void InsertJiBingUrl(string title,string url)
        {
            try
            {
                string sql = "insert into ChaJiBing(name,url) values('" + title + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch(Exception ex)
            {
                Console.Write(ex.Message);
            }
        }

        public void UpdateJiBingAttributeByUrl(string url, JiBingModel model)
        {
            string sql = "update ChaJiBing set summary='" + cutStr(model.Summary) + "',cause='" + cutStr(model.Cause) + "',prevention='" + cutStr(model.Prevention) +
                "',complication='" + cutStr(model.Complication) + "',identify='" + cutStr(model.Identify) + "',symptom='" + cutStr(model.Symptom) +
                "',inspection='" + cutStr(model.Inspection) + "',treatment='" + cutStr(model.Treatment) + "',dietHealth='" + cutStr(model.DietHealth) + "',dietTyerapy='" + cutStr(model.DietTyerapy) + "' where url='" + url + "'";
            try
            {
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

        private string cutStr(string s)
        {
            if (s.Length > 4000)
                return s.Substring(0, 4000);
            return s;
        }
        /// <summary>
        /// 从数据库中读取url
        /// </summary>
        /// <returns></returns>
        public List<String> getUrl()
        {
            List<String> urlList = new List<string>();
            try
            {
                string sql = "select url from ChaJiBing where LEN(url)>0 and summary is null";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }

    }
}
