﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace YFDYFKnowledgeDiscovery.Dao
{
    /// <summary>
    /// 疾病模型
    /// </summary>
    public class JiBingModel
    {
        /// <summary>
        /// 疾病的名称
        /// </summary>
        public string Title { set; get; }
        /// <summary>
        /// 概述
        /// </summary>
        public string Summary { set; get; }
        /// <summary>
        /// 病因
        /// </summary>
        public string Cause { set; get; }
        /// <summary>
        /// 预防
        /// </summary>
        public string Prevention { set; get; }
        /// <summary>
        /// 并发症
        /// </summary>
        public string Complication { set; get; }
        /// <summary>
        /// 鉴别
        /// </summary>
        public string Identify { set; get; }
        /// <summary>
        /// 症状
        /// </summary>
        public string Symptom { set; get; }
        /// <summary>
        /// 检查
        /// </summary>
        public string Inspection { set; get; }
        /// <summary>
        /// 治疗
        /// </summary>
        public string Treatment { set; get; }
        /// <summary>
        /// 饮食保健
        /// </summary>
        public string DietHealth { set; get; }
        /// <summary>
        /// 食疗
        /// </summary>
        public string DietTyerapy { set; get; }
    }
}
