﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class SymptomSymptomReference
    {
        static SqlConnection conn = DBHelper.getConnection();

        public List<string> getSymptomName()
        {
            List<string> symptomList = new List<string>();
            try
            {
                string sql = "select symptomName,COUNT(1) as score from goodsymptom group by symptomName order by score desc";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    symptomList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return symptomList;
        }

        public List<string> getInstructionSymptom()
        {
            List<string> list = new List<string>();
            try
            {
                string sql = "select healthFunction from HealthProductInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    list.Add(dt.Rows[i][0].ToString());
                }
                sql = "select adaption from MedicalInstrumentInstruction";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    list.Add(dt.Rows[i][0].ToString());
                }
                sql = "select mainFunction,indication,taboo from MedicineInstruction";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    list.Add(dt.Rows[i][0].ToString());
                    list.Add(dt.Rows[i][1].ToString());
                    list.Add(dt.Rows[i][2].ToString());
                }
                sql = "select mainFunction from ChineseMedicineMaterialInstruction";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    list.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return list;
        }

        public void insertSymptomSymptomReference(String symptomName1,String symptomName2,int score)
        {
            try
            {
                string sql = "insert into symptomsymptomreference values('" + symptomName1 + "','" + symptomName2 + "'," + score + ")";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
        }

        public int countReferenceScore1(String word1, String word2)
        {
            int score = 0;
            try
            {
                string sql = "select score from symptomsymptomreference where symptomName1='"+word1+"' and symptomName2='"+word2+"'";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                if (dt.Rows.Count == 1)
                {
                    score += Convert.ToInt32(dt.Rows[0][0].ToString());
                }

                sql = "select count(1) from HealthProductInstruction where healthFunction like '%" + word1 + "%' and healthFunction like '%" + word2 + "%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                score += Convert.ToInt32(dt.Rows[0][0].ToString());

                sql = "select count(1) from MedicalInstrumentInstruction where adaption like '%" + word1 + "%' and adaption like '%" + word2 + "%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                score += Convert.ToInt32(dt.Rows[0][0].ToString());

                sql = "select count(1) from ChineseMedicineMaterialInstruction where mainFunction like '%" + word1 + "%' and mainFunction like '%" + word2 + "%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                score += Convert.ToInt32(dt.Rows[0][0].ToString());

                sql = "select count(1) from MedicineInstruction where mainFunction like '%" + word1 + "%' and mainFunction like '%" + word2 + "%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                score += Convert.ToInt32(dt.Rows[0][0].ToString());

                sql = "select count(1) from MedicineInstruction where indication like '%" + word1 + "%' and indication like '%" + word2 + "%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                score += Convert.ToInt32(dt.Rows[0][0].ToString());

                sql = "select count(1) from MedicineInstruction where taboo like '%" + word1 + "%' and taboo like '%" + word2 + "%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                score += Convert.ToInt32(dt.Rows[0][0].ToString());

                sql = "select count(1) from ZhongGuoJianKangWang where symptom like '%" + word1 + "%' and symptom like '%" + word2 + "%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                score += Convert.ToInt32(dt.Rows[0][0].ToString());

                sql = "select count(1) from ChaJiBing where symptom like '%" + word1 + "%' and symptom like '%" + word2 + "%'";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                score += Convert.ToInt32(dt.Rows[0][0].ToString());
            }
            catch
            {

            }
            return score;
        }

        public int countReferenceScore2(String word1, String word2)
        {
            int score = 0;
            try
            {
                string sql = "select COUNT(1) from GoodSymptom as a,GoodSymptomBackup as b where a.symptomname='" + word1 + "' and b.symptomname='" + word2 + "' and a.url=b.url";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                score = Convert.ToInt32(dt.Rows[0][0].ToString());
            }
            catch
            {

            }
            return score;
        }
    }
}
