﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class TMall
    {
        //获取数据库连接
        static SqlConnection conn = DBHelper.getConnection();

        /// <summary>
        /// 插入商品的地址
        /// </summary>
        /// <param name="url">商品的地址</param>
        public void InsertTMallShangPinUrl(string url)
        {
            try
            {
                string sql = "insert into LinShiTMall(url) values('" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }

        /// <summary>
        /// 获取商品的链接
        /// </summary>
        public List<string> GetProductUrlList()
        {
            List<String> urlList = new List<string>();
            try
            {
                string sql = "select url from LinShiTMall where flag is null and url not like '%on_comment=1#J_TabBar%' group by url";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }
        /// <summary>
        /// 插入json数据的地址，更新时候使用
        /// </summary>
        /// <param name="productName"></param>
        /// <param name="commenturl"></param>
        public void InsertJsonUrl(string productName, string commenturl)
        {
            try
            {
                string sql = "insert into TMall(name,url) values('" + productName + "','" + commenturl + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }
        /// <summary>
        /// 更新商品的url状态，访问过为1，否则为null
        /// </summary>
        /// <param name="url"></param>
        public void UpdateFlagByUrl(string url)
        {
            try
            {
                string sql = "update LinShiTMall set flag=1 where url='" + url + "'";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }
        /// <summary>
        /// 根据URL更新
        /// </summary>
        /// <param name="strRequestUri"></param>
        /// <param name="p"></param>
        public void UpdateJsonDataByUrl(string url, string comment)
        {
            try
            {
                string sql = "update TMall set comment='" + comment + "' where url='" + url + "'";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
           
        }
        /// <summary>
        /// 通过URL更新评论数据
        /// </summary>
        /// <returns></returns>
        public List<string> getCommentJsonUrl()
        {
            List<String> urlList = new List<string>();
            try
            {
                string sql = "select url from TMall where comment is null";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }
    }
}
