﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class MedicalInstrumentInstructionSemantics
    {
        Dao.MedicalInstrumentInstruction dao = new Dao.MedicalInstrumentInstruction();
        public void saveYaoPinShiYingZheng()
        {
            List<string> auxiliaryVerbPrepositionList = Common.SemanticHelper.getAuxiliaryVerbPreposition();
            DataTable dt = dao.getSentence("MedicalInstrumentInstruction", "adaption");
            if (dt != null)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    String subject = "适用";
                    String sentence = dt.Rows[i][0].ToString();
                    String yaopin = dt.Rows[i][1].ToString();
                    String[] values = sentence.Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);
                    for (int j = 0; j < values.Length; j++)
                    {
                        for (int listI = 0; listI < auxiliaryVerbPrepositionList.Count; listI++)
                        {
                            int index = values[j].IndexOf(auxiliaryVerbPrepositionList[listI]);
                            if (index != -1)
                            {
                                values[j] = values[j].Substring(index + auxiliaryVerbPrepositionList[listI].Length);
                                listI = 0;
                            }
                        }
                        int flag = 0;
                        String[] deleteValues = { "型", "期","产品","公司","组成","部位","家庭","医疗","~" };
                        for (int k = 0; k < deleteValues.Length; k++)
                        {
                            int index = values[j].IndexOf(deleteValues[k]);
                            if (index >= 0)
                            {
                                flag = 1;
                                break;
                            }
                        }
                        if (flag == 0)
                        {
                            String value = values[j];
                            for (int k = 0; k < Common.SemanticHelper.other.Length; k++)
                            {
                                value = value.Replace(Common.SemanticHelper.other[k], "");
                            }
                            int chineseFlag = 0;
                            for (int k = 0; k < value.Length; k++)
                            {
                                if (Convert.ToInt32(Convert.ToChar(value.Substring(k, 1))) >= Convert.ToInt32(Convert.ToChar(128)))
                                {
                                    chineseFlag = 1;
                                    break;
                                }
                            }
                            if (chineseFlag == 1 && value.Length > 1)
                            {
                                dao.insertAnalysis(value);
                            }
                        }
                    }
                }
            }
        }
    }
}
