﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    class MedicineInFunction
    {

        Dao.MedicineInstruction Dao = new Dao.MedicineInstruction();

        public void savefunction()
        {
            List<string> auxiliaryVerbPrepositionList = Common.SemanticHelper.getAuxiliaryVerbPreposition();
            DataTable dt = Dao.getmainfunction();
            for(int i=0;i<dt.Rows.Count;i++)
            {
                String name = dt.Rows[i][0].ToString();
                String function = dt.Rows[i][1].ToString();
                String[] value = function.Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);
                
                for (int j = 0; j < value.Length; j++)
                {
                    for (int auxnum = 0; auxnum < auxiliaryVerbPrepositionList.Count; auxnum++)
                    {
                        int index = value[j].LastIndexOf(auxiliaryVerbPrepositionList[auxnum]);

                        if (index != -1)
                        {
                            value[j] = value[j].Substring(index + auxiliaryVerbPrepositionList[auxnum].Length);
                        }
                    }

                    for (int othint = 0; othint < Common.SemanticHelper.other.Length; othint++)
                    {
                        value[j] = value[j].Replace(Common.SemanticHelper.other[othint], "");
                    }
                    Dao.insertmainfunction(name, value[j]);
                }

                
            }
        }

        public void savaindication()
        {
            List<string> auxiliaryVerbPrepositionList = Common.SemanticHelper.getAuxiliaryVerbPreposition();
            DataTable dt = Dao.getindication();
            for(int i=0; i < dt.Rows.Count; i++)
            {
                string name = dt.Rows[i][0].ToString();
                string indication = dt.Rows[i][1].ToString();
                string[] value = indication.Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);

                for (int j = 0; j < value.Length; j++)
                {
                    for (int auxnum = 0; auxnum < auxiliaryVerbPrepositionList.Count; auxnum++)
                    {
                        int index = value[j].LastIndexOf(auxiliaryVerbPrepositionList[auxnum]);

                        if (index != -1)
                        {
                            value[j] = value[j].Substring(index + auxiliaryVerbPrepositionList[auxnum].Length);
                        }
                    }
                    for (int othint=0;othint < Common.SemanticHelper.other.Length; othint++)
                    {
                        value[j]=value[j].Replace (Common.SemanticHelper.other[othint], "");
                    }
                    Dao.insertindication(name, value[j]);
                }
            }
        }
    }
}
