﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Spider.DingXiangYuan
{
    public partial class DingXiangYuanWebBrowerFrom : Form
    {
        public DingXiangYuanWebBrowerFrom()
        {
            InitializeComponent();
            browser.ScriptErrorsSuppressed = true;
        }
        Dao.DingXiangYuan model = new Dao.DingXiangYuan();
        List<string> medicineUrlList = new List<string>();
        int urlId = 0;
        private void browser_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            // HtmlElementCollection elements = browser.Document.GetElementsByTagName("a");
            var dts = browser.Document.GetElementsByTagName("dt");
            var dds = browser.Document.GetElementsByTagName("dd");
            string url = medicineUrlList[urlId];
            List<string> dtList = new List<string>(); //存储的dt
            List<string> ddList = new List<string>(); //存储不包含详情的dd
            if (dts != null && dds != null)
            {
                for (int i = 0; i < dds.Count; i++)
                {
                    var text = dds[i].InnerText.FilterStr();
                    if (text.Contains("该信息登录才能查看，请"))
                    {
                        continue;
                    }
                    else
                    {
                        ddList.Add(text);
                    }
                }
                for (int i = 0; i < dts.Count; i++)
                {
                    var text = dts[i].InnerText.FilterStr();
                    dtList.Add(text);
                }
                for (int i = 0; i < dts.Count; i++)
                {
                    model.InsertDingXiangYuanDetail(dtList[i], ddList[i], url);
                }
                model.UpdateFlagByUrl(url);
            }
          
            content.Text = url + "爬取完成";
        }

        private void button_test_Click(object sender, EventArgs e)
        {
            Uri uri = new Uri(medicineUrlList[urlId]);

            browser.Url = uri;
            if (urlId > medicineUrlList.Count)
            {
                startButtonTrigger.Stop();
            }
            else
            {
                startButtonTrigger.Start();
            }
            urlId++;
        }

        private void startButtonTrigger_Tick(object sender, EventArgs e)
        {
            button_test_Click(button_test, null);
        }

        private void button_getUrlList_Click(object sender, EventArgs e)
        {
            medicineUrlList = model.GetMedicineUrlList();
            content.Text = "地址获取完成";
        }
    }
}
