﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HtmlAgilityPack;

namespace YFDYFKnowledgeDiscovery.Spider
{
    public partial class feihuajiankang : Form
    {
        Dao.feihuajiankang dao = new Dao.feihuajiankang();
        List<String> urlList = new List<string>();

        public feihuajiankang()
        {
            InitializeComponent();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            //获取所有症状网址
            HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn/letter/symptoms/A.html",Encoding.UTF8 );
            HtmlNodeCollection nodeCollection = HTMLHelper.getHTMLNodeByXpath("//div[@class='submenu02']//a", document);
            for (int i = 0; i < nodeCollection.Count; i++)
            {

               string zimu = nodeCollection[i].GetAttributeValue("href","");               
               HtmlAgilityPack.HtmlDocument document1 = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn" +zimu,Encoding.UTF8);               
               HtmlNodeCollection nodecollection1 = HTMLHelper.getHTMLNodeByXpath("//div[@class='pageStyle']//a", document1);

                if(nodecollection1!=null)
                {
                   string lastpage = nodecollection1[nodecollection1.Count - 1].GetAttributeValue("href", "");
                   string page1 = lastpage.Substring(0, 19);
                   int pagecount = int.Parse(lastpage.Substring(19, 1));

                   for (int j = 1; j <= pagecount; j++)
                   {
                       HtmlAgilityPack.HtmlDocument document2 = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn" + page1 + j.ToString()+ ".html", Encoding.UTF8);
                       HtmlNodeCollection nodecollection2 = HTMLHelper.getHTMLNodeByXpath("//ul[@class = 'block08 block08c']//li//a",document2);
                       for(int k=0;k<nodecollection2.Count;k++)
                       {

                           string url = "http://zzk.fh21.com.cn";
                           url += nodecollection2[k].GetAttributeValue("href","");
                           string name = nodecollection2[k].InnerText;
                           dao.saveurl(name,url);

                       }
                   }
                }
                else
                {
                    HtmlNodeCollection nodecollection3 = HTMLHelper.getHTMLNodeByXpath("//div[@class='submenu02']//a[@class='curr']", document1);
                    string url1 = nodecollection3[0].GetAttributeValue("href", "");
                    HtmlAgilityPack.HtmlDocument document3 = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn"+url1,Encoding.UTF8);

                    HtmlNodeCollection nodecollection4 = HTMLHelper.getHTMLNodeByXpath("//ul[@class = 'block08 block08c']//li//a",document3);
                    if(nodecollection4!=null)
                    {
                    for(int n=0;n<nodecollection4.Count;n++)
                    {

                        string url2 = "http://zzk.fh21.com.cn";
                        url2 +=  nodecollection4[n].GetAttributeValue("href","");
                        string name1 = nodecollection4[n].InnerText;
                        dao.saveurl(name1,url2);
                    }                   
                    }
                   
                }
               }
            MessageBox.Show("结束");
                    
            }

        private void button2_Click(object sender, EventArgs e)
        {
                   urlList = dao.geturl();
                   int s = urlList.Count;
            if (urlList != null && urlList.Count != 0)
            {
                content.Text = "地址获取成功" + s;
            }
            else
            {
                content.Text = "地址获取失败";
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {

            MessageBox.Show("开始执行");
            for (int i = 0; i < urlList.Count; i++)
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlList[i], Encoding.UTF8);
                if (document == null)
                {
                    continue;
                }
                HtmlNodeCollection nodesum = HTMLHelper.getHTMLNodeByXpath("//meta[@name='description']", document);

                //获取症状名称
                HtmlNodeCollection nodename = HTMLHelper.getHTMLNodeByXpath("//ul[@class='submenu01b']//div//h2//a", document);
                if (nodename == null)
                {
                    continue;
                }
                string name = nodename[0].InnerText;


                //获取各个信息网页
                HtmlNodeCollection nodeall = HTMLHelper.getHTMLNodeByXpath("//ul[@class='submenu01c']//li//a", document);
                if (nodeall == null)
                {
                    continue;
                }
                string urlsummarize = nodeall[0].GetAttributeValue("href", "");
                string urlpathogeny = nodeall[1].GetAttributeValue("href", "");
                string urldiagnose = nodeall[2].GetAttributeValue("href", "");
                string urlprevent = nodeall[3].GetAttributeValue("href", "");
                string urldiet = nodeall[4].GetAttributeValue("href", "");
                string urltherapy = nodeall[5].GetAttributeValue("href", "");
            //  string urlexperence = nodeall[6].GetAttributeValue("href", "");
                string urlquestion = nodeall[7].GetAttributeValue("href", "");
                string urldrug = nodeall[10].GetAttributeValue("href", "");

                string summarize = null;
                string pathogeny = null;
                string diagnose = null;
                string prevent = null;
                string diet = null;
                string therapy = null;
                string drug = null;
                

                //获取概述
                HtmlAgilityPack.HtmlDocument docsumm = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn" + urlsummarize, Encoding.UTF8);
                HtmlNodeCollection nodesu1 = HTMLHelper.getHTMLNodeByXpath("//dl[@class='z_block06a']//dd//a", docsumm);
                string href1 = nodesu1[0].GetAttributeValue("href", "");
                HtmlAgilityPack.HtmlDocument docsummarize = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn" + href1, Encoding.UTF8);
                HtmlNodeCollection nodesumm = HTMLHelper.getHTMLNodeByXpath("//div[@class='detailc']", docsummarize);
                if (nodesumm != null)
                {
                    summarize = nodesumm[0].InnerText.Trim().Replace("\n","").Replace(" ","").Replace("\r","");
                }
                //获取症状起因
                HtmlAgilityPack.HtmlDocument docpath = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn" + urlpathogeny, Encoding.UTF8);
                HtmlNodeCollection nodepath = HTMLHelper.getHTMLNodeByXpath("//div[@id='art_content']", docpath);
                if (nodepath != null)
                {
                    pathogeny = nodepath[0].InnerText.Trim().Replace("\n", "").Replace(" ", "").Replace("\r", "");
                }
                //获取鉴别诊断
                HtmlAgilityPack.HtmlDocument docdiag = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn" + urldiagnose, Encoding.UTF8);
                HtmlNodeCollection nodediag= HTMLHelper.getHTMLNodeByXpath("//div[@id='art_content']", docdiag);
                if (nodediag != null)
                {
                    diagnose = nodediag[0].InnerText.Trim().Replace("\n", "").Replace(" ", "").Replace("\r", "");
                }
                //获取如何预防
                HtmlAgilityPack.HtmlDocument docpre = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn"+urlprevent, Encoding.UTF8);
                HtmlNodeCollection nodepre = HTMLHelper.getHTMLNodeByXpath("//div[@id='art_content']", docpre);
                if (nodepre != null)
                {
                    prevent = nodepre[0].InnerText.Trim().Replace("\n", "").Replace(" ", "").Replace("\r", "");
                }
                //获取饮食宜忌
                HtmlAgilityPack.HtmlDocument docdiet = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn"+urldiet, Encoding.UTF8);
                HtmlNodeCollection nodediet = HTMLHelper.getHTMLNodeByXpath("//div[@id='art_content']", docdiet);
                if (nodediet!=null)
                {
                    diet = nodediet[0].InnerText.Trim().Replace("\n", "").Replace(" ", "").Replace("\r", "");
                }
                //获取治疗方法
                HtmlAgilityPack.HtmlDocument doctherapy = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn"+urltherapy, Encoding.UTF8);
                HtmlNodeCollection nodetherapy = HTMLHelper.getHTMLNodeByXpath("//div[@id='art_content']", doctherapy);
                if (nodetherapy != null)
                {
                    therapy = nodetherapy[0].InnerText.Trim().Replace("\n", "").Replace(" ", "").Replace("\r", "");
                }

                //获取常见药品
                //现获取页数
                
                HtmlAgilityPack.HtmlDocument docdrug = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn"+urldrug, Encoding.UTF8);
                //HtmlAgilityPack.HtmlDocument docdrug = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn/symptom/medicinal/5663.html", Encoding.UTF8);
                HtmlNodeCollection nodepage = HTMLHelper.getHTMLNodeByXpath("//div[@class='pageStyle']//a",docdrug);
                HtmlNodeCollection nodeelse = HTMLHelper.getHTMLNodeByXpath("//dd[@class='catalog04b1']//ul//h2//a",docdrug);

                if (nodepage != null)
                {
                    string urllastpage = nodepage[nodepage.Count - 1].GetAttributeValue("href", "");
                    string[] ulp = urllastpage.Split(new char[] { '&' });
                    string[] ulp1 = ulp[1].Split(new char[] { '=' });
                    int pagecount = int.Parse(ulp1[1]);
                    for (int j = 1; j <= pagecount; j++)
                    {
                        HtmlAgilityPack.HtmlDocument docpagedrug = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn" + ulp[0] + "&page=" + j.ToString() + "&scope=-1&reagent=-1&cared=-1&otc=-1&order=0", Encoding.UTF8);
                        HtmlNodeCollection nodedrugepage = HTMLHelper.getHTMLNodeByXpath("//dd[@class='catalog04b1']//ul//h2//a", docpagedrug);
                        if (nodedrugepage != null)
                        {
                            for (int k = 0; k < nodedrugepage.Count; k++)
                            {
                                drug += nodedrugepage[k].GetAttributeValue("title", "").ToString().Trim() + "||";
                            }
                        }
                        else
                        {
                            break;
                        }
                    }
                }
                else if (nodeelse != null)
                {
                    for (int k1 = 0; k1 < nodeelse.Count; k1++)
                    {
                        drug += nodeelse[k1].GetAttributeValue("title", "").ToString().Trim() + "||";
                    }
                }
                string urllistst = urlList[i];
                //将所有信息存入数据库
               dao.saveall(summarize, pathogeny, diagnose, prevent, diet, therapy, drug, urllistst);


              //获取专家答疑问题网址
                HtmlAgilityPack.HtmlDocument docquestion = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn"+urlquestion, Encoding.UTF8);
                HtmlNodeCollection nodeqpage = HTMLHelper.getHTMLNodeByXpath("//div[@class='pageStyle']//a", docquestion);
                HtmlNodeCollection nodeqelse = HTMLHelper.getHTMLNodeByXpath("//div[@class='block13']//dt//a", docquestion);
                if (nodeqpage != null)
                {
                    string urllastqpage = nodeqpage[nodeqpage.Count - 1].GetAttributeValue("href", "");
                    string[] urlquepa = urllastqpage.Split(new char[] { '-', '.' });
                    int quepagecount = int.Parse(urlquepa[1]);

                    for (int n = 1; n <= quepagecount; n++)
                    {
                        HtmlAgilityPack.HtmlDocument docquest = HTMLHelper.getHTMLContentByURL("http://zzk.fh21.com.cn" + urlquepa[0] + "-" + n.ToString() + ".html", Encoding.UTF8);
                        HtmlNodeCollection nodequest = HTMLHelper.getHTMLNodeByXpath("//div[@class='block13']//dt//a", docquest);

                        if (nodequest != null)
                        {
                            for (int m = 0; m < nodequest.Count; m++)
                            {

                                string urlquestion1 = nodequest[m].GetAttributeValue("href", "");
                                dao.savequestionurl(name, urlquestion1);
                            }
                        }
                        else
                        {
                            break;
                        }
                    }
                }
                else if (nodeqelse!=null)
                {
                    for (int m1 = 0; m1 < nodeqelse.Count; m1++)
                    {
                        string urlquestion2 = nodeqelse[m1].GetAttributeValue("href", "");
                        dao.savequestionurl(name, urlquestion2);
                    }
                }

               
            }
            MessageBox.Show("结束");
        }


        private void button5_Click(object sender, EventArgs e)
        {

            urlList = dao.getquestionurl();
            int s = urlList.Count;
            if (urlList != null && urlList.Count != 0)
            {
                content.Text = "地址获取成功" + s;
            }
            else
            {
                content.Text = "地址获取失败";
            }
    
        
        }

        private void button6_Click(object sender, EventArgs e)
        {
            MessageBox.Show("开始执行");
            for (int i=0;i<urlList.Count;i++)
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlList[i], Encoding.UTF8);
                if (document == null)
                {
                    continue;
                }

                //获取关键词
                string keyword = null;
                HtmlNodeCollection nodekey = HTMLHelper.getHTMLNodeByXpath("//meta[@name='keywords']", document);
                if (nodekey != null)
                {
                    keyword = nodekey[0].GetAttributeValue("content", "");
                }
                //获取问题
                string nodequestion = null;
                HtmlNodeCollection nodeque = HTMLHelper.getHTMLNodeByXpath("//meta[@name='description']", document);
                if(nodeque !=null)
                {
                    nodequestion = nodeque[0].GetAttributeValue("content", "").Replace("&amp;nbsp;", ",");
                }

                //获取回答
                string answer = null;
                HtmlNodeCollection nodeans = HTMLHelper.getHTMLNodeByXpath("//div[@class='iask_answer02a']//dl//dd", document);
                if (nodeans != null)
                {
                    for (int j = 0; j < nodeans.Count; j++)
                    {
                        answer += nodeans[j].InnerText.Trim().Replace("\n", "").Replace(" ", "").Replace("\r", "").Replace("&amp;nbsp;",",") + "@";
                    }

                    dao.savequestion(keyword, nodequestion, answer, urlList[i]);
                }

            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            urlList = dao.getallurl();
            int s = urlList.Count;
            if (urlList != null && urlList.Count != 0)
            {
                content.Text = "地址获取成功" + s;
            }
            else
            {
                content.Text = "地址获取失败";
            }
    
        }

        private void button4_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < urlList.Count; i++)
            {
                string department = null;
                string bodyparts = null;
                string highriskpopulation = null;
                string accompany = null;
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlList[i], Encoding.UTF8);
                HtmlNodeCollection nodedepar = HTMLHelper.getHTMLNodeByXpath("//div[@class='z_block07']//div[@itemprop='department']//dd//span", document);
                int j = 0;
                if (nodedepar != null)
                {
                    if (nodedepar.Count == 1)
                    {
                        department += nodedepar[0].InnerText;
                    }
                    else
                    {
                        for (j = 0; j < nodedepar.Count-1; j++)
                        {
                            department += nodedepar[j].InnerText + '、';
                        }
                        department += nodedepar[nodedepar.Count - 1].InnerText;
                    }
                }             
                HtmlNodeCollection nodebody = HTMLHelper.getHTMLNodeByXpath("//div[@class='z_block07']//dd[@itemprop='bodyLocation']//a", document);
                if (nodebody != null)
                {
                    if (nodebody.Count == 1)
                    {
                        bodyparts += nodebody[0].InnerText;
                    }
                    else
                    {
                        for (j = 0; j < nodebody.Count-1; j++)
                        {
                            bodyparts += nodebody[j].InnerText + '、';
                        }
                        bodyparts += nodebody[nodebody.Count - 1].InnerText;
                    }
                }

                HtmlNodeCollection nodeall = HTMLHelper.getHTMLNodeByXpath("//div[@class='z_block07']//dl//dt", document);
                HtmlNodeCollection nodeall1 = HTMLHelper.getHTMLNodeByXpath("//div[@class='z_block07']//dl//dd", document);
                if (nodeall != null && nodeall1 != null)
                {
                    for (j = 0; j < nodeall.Count; j++)
                    {
                        if (nodeall[j].InnerText.Contains("人群"))
                        {
                            highriskpopulation = nodeall1[j].InnerText;
                        }
                        else if (nodeall[j].InnerText.Contains("伴随症状"))
                        {
                            accompany = nodeall1[j].InnerText.Trim().Replace("\t","").Replace(" ","").Replace("\r","");
                        }
                    }
                }
                dao.xinxi(department, bodyparts, highriskpopulation, accompany, urlList[i]);
            }
            MessageBox.Show("结束");
        }

    

        
    }
}
